#pragma once


/* Prototype for custom yield routine */
typedef pascal OSErr (*CEncoderYielder)(void *pInContextPtr, UInt32 intInMax, UInt32 intInComplete);


#if PRAGMA_ALIGN_SUPPORTED
#pragma options align=mac68k
#endif


struct AppleSingleHeader
	{
	
		UInt32		fMagicNumber;
		UInt32		fVersion;
		UInt32		fFiller1;
		UInt32		fFiller2;
		UInt32		fFiller3;
		UInt32		fFiller4;
		UInt16		fEntries;
	
	};
	
	
typedef struct AppleSingleHeader AppleSingleHeader;


struct AppleSingleEntry
	{
	
		UInt32		fEntryID;
		UInt32		fOffset;
		UInt32		fLength;
		
	};
	

typedef struct AppleSingleEntry AppleSingleEntry;	


#if PRAGMA_ALIGN_SUPPORTED
#pragma options align=reset
#endif


typedef struct HQXContextRec HQXContextRec;


struct HQXContextRec
	{
		SInt16					fDatFileRef;
		SInt16					fResFileRef;
		UInt32					fMaxCount;
		UInt32					fCurCount;
		FSSpec					fTarget;
		CEncoderYielder	fYieldProc;
		void						*fContext;
	};
	
	
enum
	{
	
		kAppleSingleMagicNumber					= 0x00051600,
		kAppleDoubleMagicNumber					= 0x00051607,
		kAppleSingleVersion							= 0x00020000,
		kWeirdoAppleDoubleVersion				= 0x00010001,
		kAppleSingleDataFork						= 1,
		kAppleSingleResFork							= 2,
		kAppleSingleComment							= 4,
		kAppleSingleDate								= 8,
		kAppleSingleMacFInfo						= 9,
		kDefaultBufferSize							= 131072
				
	};




OSErr	FSpEncodeBinhex4(				FSSpec 														&inOutTargetSpec, 
															const CEncoderYielder							inYielder,
															void 															*pInContext,
															const SInt16											inPerm = fsRdWrPerm);
															
OSErr	FSpDecodeBinhex4(				const FSSpec											*inTargetSpec,
															const CEncoderYielder							inYielder,
															void 															*pInContext);

OSErr	HQXDataSink(						void 															*pInBuffer,
															long															intInOutCount,
															long															intInRefcon);

OSErr	HQXDataSource(					void 															*pInBuffer,
															long															*intInOutCount,
															long															intInRefcon);

OSErr HQXNameFilterProc(			StringPtr 												strOutName, 
															short 														*intOutVol, 
															long 															*intOutDir, 
															long 															intInRefcon);

OSErr FSpDecodeAppleSingle( 	const FSSpec 											*inTargetSpec, 														
															const OSType 											inCreator, 
															const OSType 											inType, 
															const ScriptCode 									inScript,
															CEncoderYielder 									inYielder, 
															void 															*pInContext);
