//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//################################################################################

/* -------------------------------------------------------------------------------

	File:				CCVSEngineItemInfoThingy.h
	
	Authors:		Ram Rajadhyaksha
	
	Description:
	
		The CCVSEngineItemInfoThingy object tells the caller whether or 
		not they can perform certain operations on the specified FSSpec.
		
		The code is very similiar to stuff found in UProjectActions.cp. 
		Eventually UProjectActions.cp should call this.
										
-------------------------------------------------------------------------------- */


#pragma once

#include <Types.h>
#include "CVSEngine.h"
#include "CCVSEntries.h"


class CCVSEngineItemInfoThingy
	{
	
		public:								
												CCVSEngineItemInfoThingy();
			virtual 					~CCVSEngineItemInfoThingy();

			virtual OSErr			GetEntry(							const FSSpec		&fsInItem,
																							Str255					pstrOutRevision,
																							Str255					pstrOutTimeStamp,
																							Str255					pstrOutOptions,
																							Str255					pstrOutTag);

/*
			virtual Boolean 	CanAdd( 							const FSSpec	 	&fsInItem);
*/
			virtual	OSErr  		CanCommit( 						const FSSpec	 	&fsInItem,
																							Boolean					&bAnswer);
/*
			virtual Boolean		CanCompareWithOriginal(const FSSpec   &fsInItem);
			virtual Boolean		CanDiff( 							const FSSpec 		&fsInItem);
			virtual Boolean		CanEdit( 							const FSSpec 		&fsInItem);		
			virtual Boolean		CanLog( 							const FSSpec 		&fsInItem);
*/
			virtual OSErr			CanMRO( 							const FSSpec 		&fsInItem,
																							Boolean					&bAnswer);
/*
			virtual Boolean		CanRemove(						const FSSpec		&fsInItem);
			virtual Boolean		CanRollback(					const FSSpec		&fsInItem);
*/
			virtual OSErr			CanTag(								const FSSpec		&fsInItem,
																							Boolean					&bAnswer);
																							
			virtual OSErr			CanUpdate(						const FSSpec		&fsInItem,
																							Boolean					&bAnswer);
/*
			virtual Boolean		CanWatch( 						const FSSpec 		&fsInItem);
*/			
		protected:
		
			CCVSEntries mEntries;
			
	};



