//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//################################################################################


/* -------------------------------------------------------------------------------

	File:				CCVSMappings.h
	
	Authors:		Ram Rajadhyaksha
	
	Description:
	
		This is a simple container class for the mappings database.
		 
	Modification History:

		24  Apr		1999		Ram Rajadhyaksha
		
				Created.
										
-------------------------------------------------------------------------------- */


#pragma once


#include <types.h>
#include "CVSEngine.h"
#include "CRadixTree.h"


class CCVSMappings
	{

		public:

								CCVSMappings();
								CCVSMappings(			CCVSEngineFileMappingRec 	*pInMappings, 
																	const UInt32 							intInCount);						
								~CCVSMappings();
			
				Boolean GetMapping( 			ConstStr255Param 					pstrInKey, 
																	CCVSEngineFileMappingRec 	&sOutMapping, 
																	const Boolean 						bInStrictCompare);
																	
				OSErr		SetMappings(			CCVSEngineFileMappingRec 	*pInMappings, 
																	const UInt32 							intInCount);

				OSErr		AddMapping( 			CCVSEngineFileMappingRec 	*pInMapping);

	  private:
	  
	  		void		BuildMappingsTree(CCVSEngineFileMappingRec 	*pInMappings, 
	  															const UInt32 							intInCount);
	  
	  	CRadixTree	*mMappings;
	  																
	};