//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//
//		File: 		CCVSServerStream.h
//
//	  Author: 	Ram Rajadhyaksha
//
//################################################################################


#ifndef __CCVSSERVERSTREAM__
#define __CCVSSERVERSTREAM__


#include <Types.h>
#include "CTCPStream.h"


class CCVSServerStream:

	public CTCPStream
	
	{
	
		public:
		
			enum
				{
				
					kCVSRSHPort						= 514,
					kCVSPServerPort				= 2401,
					kCVSKServerPort				= 1999,
					kFirstRSHPort					= 600,
					kMaxRSHPort						= 1023
								
				};
		
										CCVSServerStream(				const UInt32		inTimeOut = CTCPSocket::kDefaultTimeOut);
										~CCVSServerStream();
			
			virtual void	Login( 									CTCPSocketYieldProc	inYieldProc,
																						void						*inContextPtr,	
																						const Str255 		inServerName, 
																						const UInt16 		inPort,
																						const Str255 		inUserName, 
																						const Str255 		inPassword,
																						const Str255		inCVSRoot);
			
			virtual void AuthLogin( 							CTCPSocketYieldProc	inYieldProc,
																						void						*inContextPtr,
																						const Str255 		inServerName, 
																						const UInt16 		inPort, 
																						const Str255 		inCVSRoot );		
																													
			virtual void 	RSHLogin(								CTCPSocketYieldProc	inYieldProc,
																						void						*inContextPtr,	
																						const Str255 		inServerName, 
																						const UInt16 		inPort,
																						const Str255 		inLocalUserName,
																						const Str255		inRemoteUserName,
																						const Str255		inCVSRoot,
																						const Str255		inCVSCommand);

			friend void KClientLogin( 						CCVSServerStream 		*inStream, 
																						CTCPSocketYieldProc	inYieldProc,
																						void								*inContextPtr,
																						const Str255 				inServerName, 
																						const UInt16 				inPort, 
																						const Str255 				inCVSRoot );
	
/*																																																												
			virtual void	ReadCVSLine(						char 						*inOutDataCStr,
																						UInt32					*inOutDataLen);			
*/
			char 					*ScrambleCVSPassword(		char 						*inPassword);
			
			
			static UInt16	sRSHPort;
			
	};
	

#endif