//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//
//		File: 		CRadixTree.h
//	
//	  Author: 	Ram Rajadhyaksha
//
//################################################################################


#pragma once

#include <Types.h>


typedef struct	CRadixTreeNodeRec		CRadixTreeNodeRec;
typedef					CRadixTreeNodeRec		*CRadixTreeNodePtr;


struct CRadixTreeNodeRec 
	{

		CRadixTreeNodeRec			*fParent;
		CRadixTreeNodeRec			*fSiblings;
		CRadixTreeNodeRec			*fChildren;
		char 									*fKeyData;
		UInt32								fKeyDataLen;
		void									*fContextPtr;
		UInt32								fContextDataLen;
		Boolean								fSyntheticNode;
		
	};


class CRadixTree 
	{

		public :
		
								CRadixTree();
			
								~CRadixTree();

			void			AddKeyCStrToTree(			const char								*inKeyCStr,
																			const void								*inContextPtr,
																			const UInt32							inDataSize);
	
			void			AddKeyPStrToTree( 		const Str255 							inKeyPStr, 
																			const void 								*inContextPtr, 
																			const UInt32 							inDataSize);
																					
			Boolean		MatchKeyCStr(					const char 								*inKeyCStr,
																			void											*outContextPtr,
																			UInt32										&inOutDataSize,
																			const Boolean							inStrictCompare = true);

			Boolean		MatchKeyPStr(					const Str255 							inKeyPStr,
																			void											*outContextPtr,
																			UInt32										&inOutDataSize,
																			const Boolean							inStrictCompare = true);

		protected:
		
			void			CreateTree();
			
			Boolean		MatchRecursive(				const char 								*inKeyStr,
																			const UInt32							inKeyLen,
															 				void											*outContextPtr,
															 				UInt32										&inOutDataSize, 
																			const UInt32 							inCurIndex, 
																			CRadixTreeNodeRec					*inCurNode,
																			const Boolean							inStrictCompare);
				
			void			AddKeyRecursive(			const char 								*inKeyCStr,
																			const UInt32							inKeyLen,
																			const void								*inContextPtr, 
																			const UInt32							inDataSize,
																			const UInt32 							inCurIndex, 
																			CRadixTreeNodeRec 				*inCurNode);
										
			void			DestroyTree();
			void			DestroyTreeRecursive( CRadixTreeNodeRec 			*inCurNode);
			
			CRadixTreeNodeRec					*mRootNode;
			UInt32										mKeyCount;
			
	};
