//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//################################################################################

/* -------------------------------------------------------------------------------

	File:				StFileAccess.h
	
	Authors:		Ram Rajadhyaksha
	
	Description:
	
		StFileAccess is a stack based class meant to help with dealing with open
		files in exception safe functions. Use StFileAccess to open files, when
		the object is destroyed of, all file descriptors are closed.
		 
	Modification History:

		06 Feb 1999		Ram Rajadhyaksha
		
					Now in separate source file.
										
-------------------------------------------------------------------------------- */


#pragma once


#include <Files.h>


class StFileAccess
	{
	
		public:
		
	
														StFileAccess( 		const FSSpec 		&inTargetSpec);
														~StFileAccess();
					
			SInt16								GetFSDataForkRef( const SInt8			inPerm = fsRdWrPerm);
		 	SInt16								GetFSResForkRef(	const SInt8			inPerm = fsRdWrPerm);
			SInt16								GetResFileRef(		const SInt8			inPerm = fsRdWrPerm);
			
			void									SetDelete(		const Boolean		inDelete);									
			void									CloseAllFileRefs();
			
		protected:
			
			FSSpec									mFileSpec;
			SInt16									mFSDataForkRef;
			SInt16									mFSResForkRef;
			SInt16									mResFileRef;
			Boolean									mDeleteOnDestroy;
				
	};
	
