/*  FILE:   StringUtils.c

  Copyright  1996 - 1997 by Ram Rajadhyaksha. All rights reserved.
  Some parts copyright  others.

********************************************************************************
*
*
*
*                  G E N E R A L   I N F O R M A T I O N
*
*
*
********************************************************************************
*

  PRIMARY CONTACT:  Ram V. Rajadhyaksha (RVR)
                    http://www.best.com/~ramr
                    ramr@best.com

  REVISIONS:        01.23.97  RVR   Added PStrxx support.
                    01.12.97  RVR   Fixed bug in SkipToEOL()

                    01.01.97  RVR   Added crappy UInt32ToCStr routine.

                    12.23.96  RVR   Combined lots of string utils. in
                                    this file. Some functions still need
                                    to be implemented.

This software is freeware and provided "as-is". You are welcome to use this code
for instructional purposes. If this code or a derivative of it is used in your
software, you must give me explicit credit. Commercial use or distribution is
prohibited without prior written agreement. Questions or comments are greatly
welcome.

********************************************************************************
*
*/


#ifndef __STRINGUTILS__
#define __STRINGUTILS__


#include <Types.h>


StringPtr				PStrCopy( 		ConstStr255Param 			inSourceStr, 
															StringPtr 						outDestStr,
															SInt16 								inDestSize);
							
StringPtr				PStrConcat(		Str255 								ioFirstStr, 
															ConstStr255Param			inSecondStr,
															SInt16 								inDestSize);
																
Boolean 				PStrCompare(	const unsigned char 	*inSrc, 
															const unsigned char 	*inDst);

UInt32					CStrLen(			register char					*inStr);

void						PStrToUInt32(	unsigned char					*inStr,
															UInt32								*outNum);
								
void						CStrToUInt32(	register char					*inStr,
															register UInt32				*outNum);

void						UInt32ToStr255(	
															UInt32								inNum,
															Str255								outStr);
																
void 						UInt32ToCStr(	UInt32 								inNum, 
															char 									*outStr, 
															UInt32 								*inOutLen);

void PStrReverse( const Str255 inPStr, Str255 outReversePStr );
void PStrLowercase( Str255 inOutPStr );

#endif