//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//
//		File: 		UCVSRepositoryUtils.h
//
//	  Authors: 	Scott M. Silver and Ram Rajadhyaksha
//
//################################################################################


#pragma once


#include <Types.h>


enum
	{	
		kMaxLineSize			= 512,
		kMaxPathSize			= 512,
		kMaxFileNameSize	= 31				
	};


struct FSAsyncCopyContextRec
	{
		ParamBlockRec		sPB;
		Ptr							sBuffer;
		UInt32					sBufMax;
		UInt32					sBufIndex;
		SInt32					sSrcRef;
		SInt32					sDestRef;
		UInt32					sSrcOffset;
		UInt32					sDestOffset;
		UInt32					sCopyLen;
		UInt32					sBytesCopied;
		OSErr						sResult;
		Boolean					sKillFlag;
		Boolean					sFinished;
	};
	
	
typedef FSAsyncCopyContextRec FSAsyncCopyContextRec;
typedef FSAsyncCopyContextRec *FSAsyncCopyContextPtr;


UInt32	TruncateFileNameCStr(		const char*							inSrcName,
																char*										inDestName,
																const UInt32						inDesiredNameLen);

UInt32	TruncateFileNamePStr(		const Str255						inSrcName,
																Str255									inDestName,
																const UInt32						inDesiredNameLen);

UInt32	TruncateFileName( 			const char							*inSrcName,
																const UInt32						inSrcNameLen,
																char										*inDestName,
																const UInt32						inDesiredNameLen);

char		*CUFilterErrorHeader(		const char							*inErrorStr);


OSErr		CUCreateItemFromCVSPath(const Str255						inUserNamePStr,
																const Str255						inServerNamePStr,
																const UInt16						inPort,
																const AuthenticationMethod inAuthMethod,
																const char							*inLocalPathStr,
																const UInt32						inLocalPathLen,
																const char							*inRemotePathStr,
																const UInt32						inRemotePathLen,
																const char							*inOffsetPathStr,
																const UInt32						inOffsetPathLen,
																const char							*inCVSRootStr,
																const UInt32						inCVSRootLen,
																const	FSSpec						*inProjectRoot,
																FSSpec									*outTargetSpec,
																const CCVSEngineFileCreateInfo		*inFileCreateInfo,
																Boolean									*outCreatedItem);
																																														
UInt32	CUCountCVSPathItems(		const char						 	*inPathStr,
																const UInt32						inPathLen);

OSErr		CUCopyCVSPathItems(			const char							*inPathStr,
																const UInt32						inPathLen,
																char										*outItemStr,
																UInt32									*inOutItemLen,
																const UInt32						inItemCount);
																
OSErr		CUGetCVSPathItem(				const char						  *inPathStr,
																const UInt32						inPathLen,
																const UInt32						inItemIndex,
																Str255									outItemPStr);

OSErr		CUGetLastCVSPathItem(		const char						  *inPathStr,
																const UInt32						inPathLen,
																Str255									outItemPStr);

OSErr		CUFastGetLastCVSPathItem(	
																const char						  *inPathStr,
																const UInt32						inPathLen,
																Str255									outItemPStr);
																	
OSErr		FSWriteOffset(					const SInt32						inFileRef,
																UInt32									*inOutCount,
																void 										*inData, 
																const UInt32						inOffset,
																const UInt32 						inCacheFlags = 0);
																
OSErr		FSReadOffset(						const SInt32						inFileRef,
																UInt32									*inOutCount,
																void 										*inData, 
																const UInt32						inOffset,
																const UInt32						inCacheFlags = 0);

OSErr		FSAsyncCopy(						FSAsyncCopyContextPtr		inPB);

#ifdef powerc
void FSAsyncCopyCompletion(			register ParmBlkPtr 		inPB);
#else
void FSAsyncCopyCompletion(			register ParmBlkPtr 		inPB:__A0);	
#endif
																