//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//
//		File: 		CBroadcastTableTextView.h
//
//	  Authors:	Dan Clifford and Ram Rajadhyaksha
//
//################################################################################


#pragma once


#include <LTableView.h>
#include <LBroadcaster.h>


// In the tradition of long MacCVS names, 'tis named CBroadcastTableTextView
// Table that broadcasts msg_SelectionChanged when new cell is changed
// Its data are CColorTableText structs


struct CColorTableTextRec
	{
		
		RGBColor	fColor;
		Str255		fStr;

	};


typedef struct CColorTableTextRec CColorTableTextRec;


class	CBroadcastTableTextView: 

	public LTableView,
	public LCommander,
	public LBroadcaster
	
	{

		public:
		
			enum 				
				{ 
					
					class_ID 								= 'LCWT',
					kTextTraitsID						= 130,
					kDefaultWidth						= 1000,
					msg_SelectionChanged 		= 20001
					
				};
			
			static 					CBroadcastTableTextView*	CreateCBroadcastTableTextViewFromStream(	LStream *inStream);

		// Constructors

																								CBroadcastTableTextView( 			LStream 					*inStream);	
			virtual																		~CBroadcastTableTextView();


		// Overrides

			virtual void															FinishCreateSelf(void);
			
			virtual void															DrawCell(											const STableCell	&inCell, 	
																																							const Rect				&inLocalRect);
																																							
			virtual void															SelectionChanged();


		private:
		
			ResIDT		mTextTraits;
			FontInfo	mFontInfo;
			
	};


