//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//
//		File: 		CCompareSwitcherView.h
//
//	  Authors:	Dan Clifford and Ram Rajadhyaksha
//
//################################################################################


#include <LArray.h>
#include <LView.h>
#include <LListener.h>

class CBroadcastTableTextView;
class CCompareWithOriginalView;


class CCompareSwitcherView: 

	public LView,
	public LListener
	
	{

		public:
		
			enum 
				{ 
				
					class_ID = 'LCSW' 
					
				};
				
			static CCompareSwitcherView*	CreateCCompareSwitcherViewFromStream(		LStream 	*inStream);
			
		// Constructors
																		CCompareSwitcherView(										LStream 	*inStream);
																		~CCompareSwitcherView();
							
			virtual void 									FinishCreateSelf();

		// Overrides

			virtual void									ListenToMessage( 												MessageT 	inMessage, 
																																						void 			*ioParam);
			
		private:
		
			virtual void									SetupColors();
		
			CBroadcastTableTextView 			*mTableView;
			CCompareWithOriginalView 			*mTextView;
			LArray 												*mLineInfo;
			
			RGBColor											mAddedColor;
			RGBColor											mRemovedColor;
			RGBColor											mChangedColor;
			
	};