//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//
//		File: 		CDividedView.h
//
//	  Authors:	Ram Rajadhyaksha
//
//################################################################################

#include <LView.h>
#include <LBroadcaster.h>

	
class CDividedView:

	public LView
	
	{
	
		public:
	
	// constructors

			enum 
				{ 
				
					class_ID 							= 'CDIV',
					kDefaultDragBarSize		= 3
					
				};
		
														CDividedView();
														CDividedView(						LStream 							*inStream);
			virtual								~CDividedView();

			static	CDividedView 	*CreateCDividedViewFromStream(
																										LStream 							*inStream);

			virtual void					SetSubViews(						const PaneIDT					inPane1ID,
																										const PaneIDT					inPane2ID,
																										const UInt16					inPane1MinSize,
																										const UInt16					inPane2MinSize,
																										const UInt16					inInitialSize,
																										const UInt16					inDragBarSize,
																										const Boolean					inVertical);
	
			virtual void					FinishCreateSelf();
																															
			virtual void					ResizeFrameBy(					Int16									inWidthDelta,
																										Int16									inHeightDelta,
																										Boolean								inRefresh);
																						
			virtual void					ClickSelf(							const SMouseDownEvent	&inMouseDown);

			virtual void					AdjustCursorSelf(				Point 								inPortPt, 
																										const EventRecord			&inMacEvent);


			virtual void					DrawSelf();
			
		protected:
	
			virtual void					SetupSubPanes();
			virtual void					ReadjustSubPanes();
			
			PaneIDT			fPane1ID;
			PaneIDT			fPane2ID;
			LPane				*fPane1;
			LPane				*fPane2;
			UInt16			fPane1MinSize;
			UInt16			fPane2MinSize;
			UInt16			fInitialDelta;
			UInt16			fDragBarSize;
			Boolean			fIsVertical;	

	};
	
