//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//
//			File: 		CMacCVSApp.h
//	
//	  	Authors: 	Dan Clifford and Ram Rajadhyaksha
//
//################################################################################


#pragma once


#include <LModelObject.h>
#include <LDocApplication.h>
#include <UModalDialogs.h>
#include "CMacCVSDoc.h"


class	CMacCVSApp: 

	public LDocApplication 
	
	{

		private:
			
			typedef LDocApplication	Inherited;
			
		public:

			enum 
				{
					kAboutBoxStringID				= 400,
					kOffscreenHeight				= 192, 
					kOffscreenWidth					= 180,
					kAboutBoxRowHeight			= 13,
					kAboutBoxTextFont				= kFontIDGeneva,
					kAboutBoxTextSize				= 9,
					kAboutBoxScrollSpeed		= 3,
					kAboutBoxScrollDelay		= 60 * 3,
					kBlendStages						= 12,
					kDefaultGrowZone				= 32768,
					kDefaultSleepTime				= 40,
					kNumberOfZoomSteps			= 8
				};
				
															CMacCVSApp();		
				virtual 							~CMacCVSApp();		
					
				virtual void					ShowAboutBox();
				virtual void					RenderAboutBoxText(		Rect 								&inFrameRect, 
																										Int16 							&inOutOffset);

				virtual void					ProcessNextEvent();
				virtual void					ClickMenuBar( 				const EventRecord		&inMacEvent);
				
				virtual Boolean				ObeyCommand(					CommandT 						inCommand, 
																										void								*ioParam);	
				
				virtual void					FindCommandStatus(		CommandT 						inCommand,
																										Boolean 						&outEnabled, 
																										Boolean 						&outUsesMark,
																										Char16 							&outMark, 
																										Str255 							outName);

				static LApplication 	*GetApplication() { return sApplication; }	

				virtual void					GetSubModelByPosition(DescType						inModelID,
																										SInt32							inPosition,
																										AEDesc&							outToken) const;
				virtual LModelObject *HandleCreateElementEvent( 
																										DescType 						inElemClass, 
																										DescType 						inInsertPosition, 
																										LModelObject 				*inTargetObject, 
																										const AppleEvent		&inAppleEvent,
																										AppleEvent					&outAEReply);

				virtual LModelObject 	*MakeNewDocument();

				virtual void 					OpenDocument(					FSSpec							*inMacFSSpec);	
				virtual CMacCVSDoc		*CreateNewDocumentAt(	FSSpec							*inFileSpec,
																										const Boolean				inAskUser = true);
				void 									GetVersionPStr(				Str255 							outVersionPStr);

																													
				static LApplication 	*sApplication;
										
			protected:
		
				virtual void					Initialize();		
			
				SInt16								mAppResRef;

	};


class CSplashDialogHandler: 

	public StDialogHandler
	
	{
	
		public:
		
										CSplashDialogHandler(	ResIDT				inDialogResID,
																					LCommander		*inSuper) : 
																					
											StDialogHandler( inDialogResID, inSuper ) { }
											
										~CSplashDialogHandler() { }
	
			virtual void 	FindCommandStatus(		CommandT 			inCommand,
																					Boolean 			&outEnabled, 
																					Boolean 			&outUsesMark,
																					Char16 				&outMark, 
																					Str255 				outName);
																					
	};

	
class CSplashAttachment: 

	public LAttachment,
 	public LBroadcaster 
 	
 	{
						  
		public:
		
						CSplashAttachment(	LDialogBox			*inDialog);
		
			void	ExecuteSelf(				MessageT				inMessage, 
																void						*ioParam);

		private:
		
			LDialogBox	*mDialog;
		
	};


void OutputToLog(char *logString, Size logStringSize);
