//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//
//			File: 		CMacCVSCheckoutTask.h
//	
//	  	Authors: 	Ram Rajadhyaksha
//
//################################################################################


#pragma once


#include <LListener.h>

#include "CProgressWindow.h"
#include "CMacCVSOperationTask.h"


class CMacCVSDoc;


class CMacCVSCheckoutTask:

	public CMacCVSOperationTask,
	public LListener

	{
	
		public:
				
											CMacCVSCheckoutTask( 		const CCVSEngineCheckoutOptions		*inOptions,
																							CMacCVSDoc 												*inOwnerDoc);
																																	
			virtual 				~CMacCVSCheckoutTask();

			virtual void 		Run();	

			static pascal SInt32 Notifier(					const CCVSEngineRef 							inEngineRef,
																							const FSSpec											*inTargetItem,
																							const SInt32 											inEvent, 
																							const SInt32 											inError, 
																							const UInt32 											inCookie, 
																							const void 												*inDataPtr, 
																							void 															*inContextPtr);
																																										
			virtual void		ListenToMessage(				MessageT													inMessage,
																							void															*ioParam);
			
			virtual void		GetTaskName(						Str255														outNamePStr);
																				
		protected:
		
			CCVSEngineRef							mEngineRef;
			
			CCVSEngineCheckoutOptions	mOptions;

			UInt32										mProgressID;
			UInt32										mOldMaxValue;
			UInt32										mIterations;
			Boolean										mReset;																						
	};
	