//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//
//		File:	 	CMacCVSCompareWindow.h
//
//	  Author: Ram Rajadhyaksha
//
//################################################################################


#pragma once


#include <LCommander.h>
#include <LBroadcaster.h>
#include <LListener.h>
#include <LTextEditView.h>

#include "CSpinIndicator.h"
#include "CMacCVSThreadedWindow.h"
#include "CCompareWithOriginalView.h"
#include "CBroadcastTableTextView.h"

class CMacCVSCompareTask;

class CMacCVSCompareWindow: 	

	public CMacCVSThreadedWindow,
	public LBroadcaster 
	
	{

		private:
				
			typedef CMacCVSThreadedWindow	Inherited;

		public:
		 
			enum 
				{
			
					class_ID											= 'CVDI',
					kMacCVSCompareWindowID				= 152
			
				};
			
																	CMacCVSCompareWindow(										LStream 									*inStream);
			
			virtual 										~CMacCVSCompareWindow();
		
			static CMacCVSCompareWindow *CreateCMacCVSCompareWindowFromStream(	LStream 										*inStream);
			
			virtual void								FinishCreateSelf();
					
			virtual void								Compare(														const FSSpec								*inTargetItem,
																																		 	CMacCVSDoc									*inOwnerDoc,
																																		 	const void 									*inCommandData,
																																		 	UInt32 											inDelayTicks = 0);
			
			static pascal SInt32 				DiffNotifier(												const CCVSEngineRef 				inEngineRef, 
																																			const UInt32 								inDataType, 
																																			const UInt32 								inDataLen, 
																																			const void 									*inData, 
																																			void 												*inContextPtr);

			virtual void								ParseDiffOutput();
																			
		protected:

																																				
			CCompareWithOriginalView		*mCompareView;
			CBroadcastTableTextView			*mCompareTable;
			Handle											mDataHndl;
			FSSpec											mTargetItem;
			
	};

