//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//
//		File:	 	CMacCVSDiffWindow.h
//
//	  Author: Ram Rajadhyaksha
//
//################################################################################


#pragma once


#include <LCommander.h>
#include <LBroadcaster.h>
#include <LListener.h>
#include <LTextEditView.h>

#include "CSpinIndicator.h"

#include "CCompareWithOriginalView.h"
#include "CMacCVSStatusTask.h"


class CMacCVSDiffWindow: 	

	public LWindow,
	public LBroadcaster 
	
	{

		public:
		 
			enum 
				{
			
					class_ID											= 'CVDI',
					kMacCVSDiffWindowID						= 152
			
				};
			
																	CMacCVSDiffWindow(										LStream 									*inStream);
			
			virtual 										~CMacCVSDiffWindow();
		
			static CMacCVSDiffWindow 		*CreateCMacCVSDiffWindowFromStream(	LStream 										*inStream);
			
			virtual void								FinishCreateSelf();
					
			virtual void								Diff(																const FSSpec								*inTargetItem,
																																		 	CMacCVSDoc									*inOwnerDoc);
			
			static pascal SInt32 				DiffNotifier(												const CCVSEngineRef 				inEngineRef, 
																																			const UInt32 								inDataType, 
																																			const UInt32 								inDataLen, 
																																			const void 									*inData, 
																																			void 												*inContextPtr);
					
			virtual void								TurnOnSpinnyThingy(void);
			virtual void								TurnOffSpinnyThingy(void);
	
			virtual void								ThreadedTaskDied(										const CThreadedTask					*inTask);
													
		protected:

			virtual void								ParseDiffOutput();
																																				
			CThreadedTask 							*mDiffTask;
			CSpinIndicator							*mSpinnyThingy;
			CCompareWithOriginalView		*mCompareView;
			Handle											mDataHndl;
			FSSpec											mTargetItem;
			
	};

