//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//
//			File: 		CMacCVSLogTask.h
//	
//	  	Authors: 	Ram Rajadhyaksha
//
//################################################################################


#pragma once


#include <LHandleStream.h>
#include "CMacCVSWindowTask.h"
#include "CVSEngine.h"


class CMacCVSLogWindow;
class CMacCVSDoc;


class CMacCVSLogTask:

	public CMacCVSWindowTask
	
	{
	
		public:
		
			enum
				{				
					kReadNothing				= 0,
					kReadHeader					= 1,
					kReadRevision				= 2,
					kReadDate						= 3,
					kReadBranches				= 4,
					kReadingComment			= 5,
					kBufMax							= 1024,
					kDefaultYieldCount	= 20				
				};
				
							
											CMacCVSLogTask(				const CMacCVSLogWindow 				*inOwnerWindow,
																					 	CMacCVSDoc 										*inOwnerDoc,
																						const FSSpec									*inTargetItem);
																																						
			virtual 				~CMacCVSLogTask();

			virtual OSErr		DoEngineCommand();
			
			virtual void		ProcessData();
	
			static pascal SInt32 
											Notifier(							const CCVSEngineRef 					inEngineRef,
																						const FSSpec									*inTargetItem,
																						const SInt32 									inEvent, 
																						const SInt32 									inError, 
																						const UInt32 									inCookie, 
																						const void 										*inDataPtr, 
																						void 													*inContextPtr);
		
			static pascal SInt32 
											LogNotifier(					const CCVSEngineRef 					inEngineRef, 
																						const UInt32									inDataType,
																						const UInt32 									inDataLen, 
																						const void 										*inData, 
																						void 													*inContextPtr);

			virtual void		GetTaskName(					Str255												outNamePStr);
																																
		protected:
				
			FSSpec								mTargetItem;	
			UInt32								mParsingState;
			Str255								mAuthorPStr;
			Str255								mRevisionPStr;
			SInt32								mDate;
			
			char									mBuffer[kBufMax];
			UInt32								mBufLen;
			LHandleStream					mStream;
			LHandleStream					mCommentStream;
																											
	};
	