//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//
//		File: 	CMacCVSLogWindow.h
//
//	  Author: Ram Rajadhyaksha
//
//################################################################################


#pragma once


#include <LWindow.h>
#include <LBroadcaster.h>
#include <LListener.h>


#include "CThreadedTask.h"
#include "CSpinIndicator.h"
#include "CMacCVSLogView.h"
#include "CMacCVSLogTask.h"
#include "CMacCVSThreadedWindow.h"

class CMacCVSDoc;


class CMacCVSLogWindow:	

	public CMacCVSThreadedWindow 
	
	{
	
	private:
		
		typedef 	CMacCVSThreadedWindow		Inherited;


		public:
		
			enum 
				{
			
					class_ID										= 'LGWN',
					kMacCVSLogWindowID					= 150,
					kMacCVSStatusSpinPaneID			= 'spin',
					kSortByDateButtonID					= 'stdt',
					kSortByVersionButtonID			= 'stvr',
					kSortByAuthorButtonID				= 'stau'
			
				};

																	CMacCVSLogWindow(							LStream 					*inStream);
			virtual											~CMacCVSLogWindow();
			
			static CMacCVSLogWindow * 	CreateCMacCVSLogWindowFromStream(LStream				*inStream);
			
			virtual void 								FinishCreateSelf();

			virtual void								Log( 													const FSSpec 			*inTargetItem, 
																															 	CMacCVSDoc 				*inOwnerDoc,
																															 	UInt32 						inDelayTicks = 0);

			virtual void 								AddLogEntry(									const Str255 			inAuthorPStr, 	
																																const Str255 			inVersionPStr, 
																																const UInt32 			inDate,			
																																const char 				*inCommentStr,
																																const UInt32			inCommentLen);
																																
			void 												TurnOnSpinnyThingy(void);
			void 												TurnOffSpinnyThingy(void);
																	
		protected:
		
			CMacCVSLogView			*mLogView;
			
	};

