//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//################################################################################

/* -------------------------------------------------------------------------------

	File:				CMacCVSLurkersTask.h
	
	Authors:		Ram Rajadhyaksha, Simon Fraser
	
	Description:
	
		This file contains the code to find lurker files.
		 
	Modification History:

		10 Jan 1998			Ram Rajadhyaksha
		
					Made several changes for compatiblity with Entries files.
							
-------------------------------------------------------------------------------- */


#pragma once


#include <LArray.h>
#include "CThreadedTask.h"
#include "CCVSEntries.h"


class CMacCVSDoc;


class CMacCVSLurkersWindow;



typedef enum {
	kLurkersMatchIgnoreTag = 1,			// to match the menu items
	kLurkersMatchMatchTag,
	kLurkersMatchDontMatchTag
} TLurkersMatch;

struct CMacCVSLurkersQueryRec
	{
	
		Str255					fTagPStr;
		TLurkersMatch		fMatchTag;
		Boolean					fFindOnlyMRO;
		Boolean					fFindNewFiles;
	};
	
	
typedef struct CMacCVSLurkersQueuryRec CMacCVSLurkersQueuryRec;


class CMacCVSLurkersTask:

	public CBroadcastingThreadedTask
	
	{
	
		public:
				
			enum
				{
				
					kDefaultLurkersThreadStackSize	= 32768,
					kMinimumLurkersThreadStackSize	= 4096,
					kDefaultYieldCount							= 16
				
				};
						
											CMacCVSLurkersTask(		const CMacCVSLurkersWindow 		*inOwnerWindow,
																						const CMacCVSLurkersQueryRec  *inQuery,
																						const LArray									*inTargetItems);
																											
			virtual 				~CMacCVSLurkersTask();

			virtual void 		RunSelf();	
					
		protected:

			virtual void		FindLurkers(					const CInfoPBRec							*inParentPB);	
																																		
			CMacCVSLurkersWindow		*mOwnerWindow;
			CMacCVSDoc							*mOwnerDoc;
			CMacCVSLurkersQueryRec	mQuery;
			
			LArray									mItemList;
			CCVSEntries							mEntries;
			
			static UInt32						sYieldCount;
																														
	};
	