//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//
//		File: 	CMacCVSLurkersWindow.h
//
//	  Author: Ram Rajadhyaksha
//
//################################################################################


#pragma once


#include <LWindow.h>
#include <LBroadcaster.h>
#include <LListener.h>

#include "CSpinIndicator.h"
#include "CThreadedTask.h"
#include "CMacCVSThreadedWindow.h"
#include "CMacCVSLurkersTask.h"
#include "CMacCVSLurkersView.h"


class CMacCVSDoc;


class CMacCVSLurkersWindow:	

	public CMacCVSThreadedWindow
	
	{
	
	private:
		
		typedef 	CMacCVSThreadedWindow		Inherited;

		public:
		
			enum 
				{
			
					class_ID											= 'LUWN',
					kMacCVSLurkersWindowPPobID		= 133,
					kSortByStatusButtonID					= 'stst',
					kSortByNameButtonID						= 'stnm',
					kSortByVersionButtonID 				= 'stvr',
					kSortByModDateButtonID				= 'stdt',
					kSortByTagButtonID						= 'sttg'
			
				};

																	CMacCVSLurkersWindow(					LStream 												*inStream);
			virtual											~CMacCVSLurkersWindow();
			
			static CMacCVSLurkersWindow *CreateCMacCVSLurkersWindowFromStream(
																																LStream													*inStream);
			
			virtual void 								FinishCreateSelf();
				
			void												FindLurkers(									const CMacCVSDoc								*inOwnerDoc,
																																const LArray										*inTargetItems,
																																const CMacCVSLurkersQueryRec		*inQueryRec);
																																		
			void												AddProjectItem( 							const FSSpec 										*inItemFileSpec);																										
			virtual void								ThreadedTaskDied( 						const CThreadedTask 						*inTask );

			void 												TurnOnSpinnyThingy(void);
			void 												TurnOffSpinnyThingy(void);
														
		protected:
		
			CMacCVSLurkersView		*mLurkersView;
			
	};

