//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//
//		File: 		CMacCVSMappingsView.h
//
//		Authors: 	Ram Rajadhyaksha
//
//################################################################################


#pragma once


#include <LTableView.h>
#include <LArray.h>
#include "CVSEngine.h"


typedef UInt32 CMacCVSLurkersViewEventType;
typedef UInt32 CMacCVSLurkersViewSortType;


enum
	{
	
//  CVS New Encoding Window

		kMacCVSNewEncodingDialogPPobID							= 146,
		kMacCVSNewEncodingDialogOKButtonID					= 'okok',
		kMacCVSNewEncodingDialogCancelButtonID			= 'cncl',
		kMacCVSNewEncodingDialogSuffixEditFieldID		= 'SFEF',
		kMacCVSNewEncodingDialogTypeEditFieldID			= 'FTEF',
		kMacCVSNewEncodingDialogCreatorEditFieldID	= 'FCEF',
		kMacCVSNewEncodingDialogTranslationPopupID	= 'TRAP',
		kMacCVSNewEncodingDialogEncodingPopupID			= 'ENCP',
		kUNIXLFTranslationMenuItem									= 1,
		kMacintoshLFTranslationMenuItem							= 2,
		kTextEncodingMenuItem												= 1,
		kBinaryEncodingMenuItem											= 2,
		kAppleSingleEncodingMenuItem								= 3,
		kBinhex4EncodingMenuItem										= 4,
		kMacBinaryEncodingMenuItem									= 5,
		kRBLEncodingMenuItem												= 6
			
	};
	
	
class CMacCVSMappingsView: 	

	public LTableView,
	public LBroadcaster
	
	{
				
		public :
			
			enum 
				{
				
					class_ID												= 'MapV',
					kCMacCVSMappingsViewMessage			= 'MapV',

					kCellIconOffset									= 16, 
					kCellExtensionTextOffset				= 2,
					kCellTypeTextOffset							= 55,
					kCellCreatorTextOffset					= 87,
					kCellTranslationTextOffset			= 131,
					kCellEncodingOffset							= 187,
					kFileStatusIconWidth						= 16,
					kFileStatusIconHeight						= 16,
					kCellTextTraitsID								= 130,
					kCellTextOffsetFromBottom				= 5,

					kDefaultRowWidth								= 200,
					kDefaultRowHeight								= 16

				};
		
			static CMacCVSMappingsView 	*CreateCMacCVSMappingsViewFromStream(LStream								*inStream);
			
																	CMacCVSMappingsView(					LStream 											*inStream);
			virtual											~CMacCVSMappingsView();
			
			virtual TableIndexT					AddNewItem();
			virtual void								EditCurrentItem();
			
			virtual TableIndexT					InsertNewItem(								const CCVSEngineFileMappingRec	&inItem);
				
			virtual TableIndexT					GetSelectedItem(							CCVSEngineFileMappingRec			&outItem);
																													
			virtual Boolean							RemoveItem(										const TableIndexT							inRow,
																																CCVSEngineFileMappingRec			&outItem);
			
			Boolean											IsDirty() 
				{ 
					
					return mDirty; 
					
				}
				
			void												SetDirtyFlag(									const Boolean									inFlag)
				{ 
				
					mDirty = inFlag; 
					
				}
				
		protected:
		
			virtual	void								FinishCreateSelf(void);

			//	Drawing
	
			virtual	void								DrawSelf(void);
			
			virtual	void 								DrawCell(											const STableCell							&inCell,
																																const Rect										&inLocalRect);

			virtual	void								DrawCellIcon(									const STableCell							&inCell,
																																const Rect										&inLocalRect,
																																Boolean												inHilite);

			virtual void								ClickSelf(										const SMouseDownEvent					&inMouseDown);
																																
			virtual void 								ClickCell(										const STableCell							&inCell,
																																const SMouseDownEvent					&inMouseDown);
			
			Boolean		mDirty;
									
	};

