//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//################################################################################

/* -------------------------------------------------------------------------------

	File:				CMacCVSOperationTask.h
	
	Authors:		Ram Rajadhyaksha and Simon Fraser
	
	Description:
	
		Code to implement the basic CVS operation in MacCVS Pro.
		 
	Modification History:

		17 Feb 1999			Ram Rajadhyaksha
		
					CMacCVSOperationTask now inherits from CMacCVSThreadedTask.
							
-------------------------------------------------------------------------------- */


#pragma once


#include "CMacCVSThreadedTask.h"
#include "CVSEngine.h"


class CMacCVSDoc;

struct CVSTaskID
	{
		enum
			{
				eAddTaskID 				= 'addt',
				eCommitTaskID 		= 'comt',
				eUpdateTaskID 		= 'updt',
				eCheckoutTaskID		= 'co  ',
				eLogTaskID 				= 'log ',
				eRemoveTaskID			= 'kill',
				eImportTaskID			= 'impt',
				eTagTaskID				= 'tag '
			};
	};


class CMacCVSOperationTask:

	public CMacCVSThreadedTask

	{
				
		public:
	
			enum
				{
					kDefaultCMacCVSOperationTaskStackSize = 48 * 1024
				};
												
											CMacCVSOperationTask(		LStream											*inStream,
																							const UInt32 								inStackSize = kDefaultCMacCVSOperationTaskStackSize);
											
											CMacCVSOperationTask( 	CMacCVSDoc									*inOwnerDoc,
																							const UInt32 								inStackSize = kDefaultCMacCVSOperationTaskStackSize);
																											
			virtual 				~CMacCVSOperationTask();
			
																																															
			static pascal SInt32 MessageOutNotifier(const CCVSEngineRef					inEngineRef, 
																							const UInt32								inDataType,
																							const UInt32 								inDataLen, 
																							const void 									*inData, 
																							void 												*inContextPtr);
				
			static pascal SInt32 ErrorOutNotifier( 	const CCVSEngineRef 				inEngineRef, 
																							const UInt32								inDataType,
																							const UInt32 								inDataLen, 
																							const void 									*inData, 
																							void 												*inContextPtr);
																															
		protected:
		
			Handle											mMessageOutStream;
			Handle											mErrorOutStream;
			Handle											mAdditionalPostData;

			CCVSEngineFileMappingRec 		*mMappings;
			UInt32											mMappingsCount;
			
	};
	
