//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//
//			File: 		CMacCVSOrphanFilesTask.h
//	
//	  	Authors: 	Ram Rajadhyaksha
//
//################################################################################


#pragma once


#include <LArray.h>
#include "CProgressWindow.h"

#include "CMacCVSOperationTask.h"

class CMacCVSDoc;
class CProgressWindow;



typedef enum 
	{
		kOrphanFilesRemoveCkid = 1,			// to match the menu items
		kOrphanFilesRemoveMcvs,
		kOrphanFilesRemoveDirectories
	} TOrphanFilesMatch;


struct CMacCVSOrphanFilesQueryRec
	{	
		Boolean					fRemoveCkid;
		Boolean					fRemoveMcvs;
		Boolean					fRemoveCvsDirecories;
		
		Boolean					fOrphanEntireTree;	
	};
	
	
typedef struct CMacCVSOrphanFilesQueuryRec CMacCVSOrphanFilesQueuryRec;


class CMacCVSOrphanFilesTask:

	public CMacCVSThreadedTask,
	public LListener
		
	{
	
		public:
				
			enum
				{				
					kDefaultOrphanFilesThreadStackSize	= 16384,
					kMinimumOrphanFilesThreadStackSize	= 4096,
					kDefaultYieldCount									= 16				
				};
						
											CMacCVSOrphanFilesTask(		CMacCVSDoc 													*inOwnerDoc,
																								const CMacCVSOrphanFilesQueryRec  	*inQuery,
																								const LArray												*inTargetItems);
																											
			virtual 				~CMacCVSOrphanFilesTask();

			virtual void 		RunSelf();	
				
				
			virtual void		ListenToMessage( 					MessageT 														inMessage, 
																								void 																*ioParam );

		protected:

			virtual void		DoOrphanFiles(						const FSSpec 												*inFileSpec,
																								Boolean 														&outRemovedDirectory);	
					
			void						NoteFileFolderCleaned( 		ConstStr255Param 										inFileFolderName );
												
																												
			CMacCVSOrphanFilesQueryRec	mQuery;
			
			LArray											mItemList;
			UInt32											mProgressID;
			UInt32											mFilesCleaned;			
			static UInt32								sYieldCount;
																														
	};
	