//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//
//		File: 		CMacCVSProjectViewFile.h
//
//	  Authors: 	Dan Clifford and Ram Rajadhyaksha
//
//################################################################################


#pragma once


#include "CMacCVSProjectViewItem.h"


class LMacCVSProjectFolder;


class CMacCVSProjectViewFile: 

	public CMacCVSProjectViewItem 

	{

		public :
					
																	CMacCVSProjectViewFile(	CMacCVSProjectViewItem		*inParentItem, 
																													const FSSpec 							*inFileSpec,
																													Boolean										inIsAlias = false);
															
			virtual 										~CMacCVSProjectViewFile();

			static CMacCVSProjectViewItem *CreateInstance(			CMacCVSProjectViewItem		*inParentItem, 
																													const FSSpec 							*inFileSpec);

			//	Accessors
		
			virtual Boolean							CanBeAdded();
			virtual Boolean							CanCheckin();
			virtual Boolean 						CanCompareWithOriginal();
			virtual Boolean							CanDiff();
			virtual Boolean							CanRemove();
			virtual Boolean							CanRevert();
			virtual Boolean							CanTag();
			virtual Boolean							CanUpdate();
			
			virtual void								GetVersionPStr(					Str255										outVersionPStr);
			virtual void								GetVersionCStr(					char 											*outVersionCStr);
			
			virtual ProjectItemStatus 	GetProjectItemStatus();

			virtual void								GetCreatorAndType(			OSType 										&fileCreator, 
																													OSType 										&fileType);
		
			virtual void								SetEntry(								Str255										pstrInRevision,
																													Str255										pstrInTimeStamp,
																													Str255										pstrInOptions,
																													Str255										pstrInTag);
																													
			virtual Boolean							IsOutOfDate();
	
			Handle											GetCheckoutComment();
		
			virtual void								ValidateContents(				const FSSpec 							*inProjectRootFileSpec);
							
			//  Version Comparator
			
			static Int32								CompareVersion(					CMacCVSProjectViewItem		*inItemOne,
																													CMacCVSProjectViewItem		*inItemTwo);
															
			static Boolean							IsEqualVersion(					CMacCVSProjectViewItem		*inItemOne,
																													CMacCVSProjectViewItem  	*inItemTwo);
															
			static SInt32								CompareCVSVersion(			char 											*inVersion1Str, 
																													char 											*inVersion2Str);
			
		protected:

			ProjectItemStatus			mCachedProjectorStatus;
			Boolean								mBinaryData;
			
			Str255								mFileVersionString;
			Str255								mTimeStamp;
				
	};

