//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//
//		File: 		CMacCVSProjectViewFolder.h
//
//	  Authors: 	Dan Clifford and Ram Rajadhyaksha
//
//################################################################################


#pragma once


#include <Types.h>
#include <Files.h>

#include "CCVSEntries.h"
#include "CMacCVSProjectViewItem.h"


class CMacCVSProjectViewFolder : public CMacCVSProjectViewItem 
	{
		
		public:
		
			enum 
				{
				
					kDefaultYieldCount = 16
					
				};
					
													CMacCVSProjectViewFolder(			CMacCVSProjectViewItem		*inParentItem, 
																												const FSSpec 							*inFileSpec,
																												Boolean										inIsAlias = false);
									
			virtual							~CMacCVSProjectViewFolder();
		
			//	Accessors
			
			virtual LArray			*GetContainedItemsPtr();
			virtual UInt32			GetTotalContainedItemCount();
			
			virtual Boolean			IsCVSContainer() const;
			virtual	Boolean			IsContainer() const;
			virtual Boolean 		IsOutOfDate();
			
			virtual void				SetOpenStatus(								Boolean 									inNewOpenStatus);
			virtual Boolean			GetOpenStatus();
			
			void								SetComparator( 								LComparator 							*inComparator);
			
			virtual void				ValidateContents(							const FSSpec							*inProjectRootFileSpec);
			virtual LArray			*ValidateContentsChanged(			const FSSpec							*inProjectRootFileSpec);
			virtual void				ValidatePartially();
			
			virtual UInt32			FindProjectItem(							StringPtr									inFileNamePStr);

		private:
		
			LArray							*mContents;
			Boolean							mOpenStatus;
			Boolean							mCVSContainer;
			UInt32							mYieldCount;
			SInt32							mCachedEntriesModDate;
			CCVSEntries					*mEntries;
			
	};

