//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//
//		File: 	CMacCVSProjectViewSelector.h
//
//	  Author: Scott M. Silver and Ram Rajadhyaksha
//
//################################################################################


#include "CTableDragSelector.h"
#include "CMacCVSProjectView.h"


class CMacCVSProjectViewSelector: 

	public CTableDragSelector
	
	{
		
		friend class CMacCVSProjectView;
		
		public:
								
												CMacCVSProjectViewSelector(	CMacCVSProjectView	*inProjectView);
									
			virtual void			HandleDrag(					const STableCell				&inCell,
																						const SMouseDownEvent		&inMouseDown);
			
			virtual Boolean		HitCellHotSpot(			const STableCell				&inCell,
																						const Rect							&inTotalSelectionRect);
		
			virtual void			UserDraggedSelection();
	
			virtual void			PreScroll(					const SPoint32					inScroll);
			virtual void			PostScroll();
		
		protected:
		
			CMacCVSProjectView		*mProjectView;
			SPoint32							mOldScroll;																		
	};
	
