//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//
//		File: 	CMacCVSProjectViewWindow.h
//
//	  Author: Ram Rajadhyaksha
//
//################################################################################


#pragma once


#include <LWindow.h>
#include <LBroadcaster.h>
#include <LListener.h>

#include "CThreadedTask.h"

#include "CSpinIndicator.h"
#include "CMacCVSProjectView.h"
#include "CMacCVSThreadedWindow.h"


class CMacCVSDoc;


class CMacCVSProjectViewWindow:	

	public CMacCVSWindow
	
	{
	
		private:
			
			typedef			CMacCVSWindow			Inherited;
			
		public:
		
			enum 
				{
			
					class_ID												= 'PVWD',
					kMacCVSProjectViewWindowPPobID	= 128,
					kSortByStatusButtonID						= 'stst',
					kSortByNameButtonID							= 'stnm',
					kSortByVersionButtonID 					= 'stvr',
					kSortByModDateButtonID					= 'stdt',
					kSortByTagButtonID							= 'sttg'
			
				};

																	CMacCVSProjectViewWindow(			LStream 												*inStream);
																	
																	CMacCVSProjectViewWindow(			LStream 												*inStream,
																																CMacCVSDoc 											*inOwnerDoc);

			virtual											~CMacCVSProjectViewWindow();
			
			static CMacCVSProjectViewWindow *CreateCMacCVSProjectViewWindowFromStream(
																																LStream													*inStream,
																																CMacCVSDoc 											*inOwnerDoc);
		
			virtual void 								FinishCreateSelf();
						
			virtual void								SelectFile(										const FSSpec										*inFileSpec);
			
			virtual Boolean							GetWindowRootFolder( 					 			FSSpec 										&outFileSpec );
		
			virtual void								SetWindowPosition();
			virtual void								SaveWindowPosition();
	
			virtual void								ClickInDrag( 									const EventRecord								&inMacEvent );

			virtual void 								FindCommandStatus( 						CommandT 												inCommand,
																																Boolean 												&outEnabled,
																																Boolean 												&outUsesMark, 
																																Char16 													&outMark, 
																																Str255 													outName);

			virtual Boolean							ObeyCommand( 									CommandT 												inCommand,
																																void														*ioParam);

			virtual void			GetSubModelByName(				DescType							inModelID,
																									Str255								inName,
																									AEDesc								&outToken) const;
			virtual void			GetSubModelByPosition(		DescType							inModelID,
																									SInt32								inPosition,
																									AEDesc								&outToken) const;					
			virtual SInt32		CountSubModels(						DescType 							inModelID) const;

		protected:
						
			CMacCVSProjectView		*mProjectView;
			CSpinIndicator				*mSpinnyThingy;
			
	};

