//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//
//			File: 		CMacCVSStatusTask.h
//	
//	  	Authors: 	Ram Rajadhyaksha
//
//################################################################################


#pragma once


#include "CMacCVSWindowTask.h"


class CMacCVSStatusWindow;
class CMacCVSDoc;


class CMacCVSStatusTask:

	public CMacCVSWindowTask

	{
	
		public:
		
											CMacCVSStatusTask(		const CMacCVSStatusWindow 		*inOwnerWindow,
																					 	CMacCVSDoc 										*inOwnerDoc,
																						const FSSpec									*inTargetItem);									
																						
			virtual 				~CMacCVSStatusTask();
			
			virtual OSErr		DoEngineCommand();

			static pascal SInt32 
											Notifier(							const CCVSEngineRef 					inEngineRef,
																						const FSSpec									*inTargetItem,
																						const SInt32 									inEvent, 
																						const SInt32 									inError, 
																						const UInt32 									inCookie, 
																						const void 										*inDataPtr, 
																						void 													*inContextPtr);

			virtual void 		GetTaskName( 					Str255 												outNamePStr);
		
		protected:
			
			FSSpec mTargetItem;
																						
	};



class CMacCVSDiffTask:

	public CMacCVSWindowTask

	{
	
		public:
		
											CMacCVSDiffTask(			const CMacCVSStatusWindow 		*inOwnerWindow,
																					 	CMacCVSDoc 										*inOwnerDoc,
																						const FSSpec									*inTargetItem,
																						const CCVSEngineDiffOptions		*inDiffOptions);
																																	
			virtual 				~CMacCVSDiffTask();
			
			virtual OSErr		DoEngineCommand();

			static pascal SInt32 
											Notifier(							const CCVSEngineRef 					inEngineRef,
																						const FSSpec									*inTargetItem,
																						const SInt32 									inEvent, 
																						const SInt32 									inError, 
																						const UInt32 									inCookie, 
																						const void 										*inDataPtr, 
																						void 													*inContextPtr);

		protected:
		
			FSSpec									mTargetItem;
			CCVSEngineDiffOptions		mDiffOptions;
																									
	};
	