//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//
//		File:	 	CMacCVSStatusWindow.h
//
//	  Author: Ram Rajadhyaksha
//
//################################################################################


#pragma once


#include <LCommander.h>
#include <LBroadcaster.h>
#include <LListener.h>
#include <LTextEditView.h>

#include "CSpinIndicator.h"
#include "CVSEngine.h"
#include "CMacCVSStatusTask.h"
#include "CMacCVSThreadedWindow.h"

class CMacCVSStatusWindow: 	

	public CMacCVSThreadedWindow
	
	{

		private:
				
			typedef CMacCVSThreadedWindow	Inherited;
			
		public:
		 
			enum 
				{	
					class_ID											= 'CVSL',
					kMacCVSStatusWindowID					= 151,
					kMacCVSStatusSpinPaneID				= 'spin',
					kMacCVSStatusTEPaneID					= 'CVST',
					kMaximumTextLen								= 31 * 1024			
				};
			
																	CMacCVSStatusWindow(									LStream 										*inStream);			
			virtual 										~CMacCVSStatusWindow();
		
			static CMacCVSStatusWindow 	*CreateCMacCVSStatusWindowFromStream(	LStream 										*inStream);
			
			virtual void								FinishCreateSelf();
					
			virtual void								Status(															const FSSpec								*inTargetItem,
																																		 	CMacCVSDoc									*inOwnerDoc,
																																			const Boolean								inDoDiff = false,
																																			const void									*inCommandData = NULL,
																																			UInt32 											inDelayTicks = 0);

			virtual void								ShowEditors( 												const FSSpec 								*inTargetItem, 
																																			CMacCVSDoc 									*inOwnerDoc, 
																																			UInt32 											inDelayTicks = 0);

			virtual void								ShowWatchers( 											const FSSpec 								*inTargetItem, 
																																			CMacCVSDoc 									*inOwnerDoc, 
																																			UInt32 											inDelayTicks = 0);
			
			static pascal SInt32				StatusNotifier( 										const CCVSEngineRef					inEngineRef,
																																			const UInt32								inDataType,
																																			const UInt32								inDataLen,						
																																			const void 									*inData, 
																																			void												*inContextPtr);
			
			virtual void								FindCommandStatus( 									CommandT										inCommand,
																																			Boolean 										&outEnabled,
																																			Boolean 										&outUsesMark,
																																			Char16 											&outMark,
																																			Str255 											outName);

			virtual Boolean							ObeyCommand( 												CommandT 										inCommand,
																																			void 												*ioParam);
			
		protected:
			
			LTextEditView						*mTextView;
			Handle									mDataHndl;
			
	};

