//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//################################################################################

/* -------------------------------------------------------------------------------

	File:				CMacCVSThreadedTask.h
	
	Authors:		Ram Rajadhyaksha and Simon Fraser
	
	Description:
	
		Code to implement the basic threaded operation in MacCVS Pro.
		 
	Modification History:

		17 Feb 1999			Ram Rajadhyaksha
		
					File created.
							
-------------------------------------------------------------------------------- */


#pragma once


#include "CThreadedTask.h"


class CMacCVSDoc;


class CMacCVSThreadedTask:

	public CBroadcastingThreadedTask

	{
	
		public:
		
			enum
				{				
					kDefaultCMacCVSThreadedTaskStackSize	= 32 * 1024					
				};
						
											CMacCVSThreadedTask();										
											CMacCVSThreadedTask(		LStream											*inStream,
																							const UInt32 								inStackSize = kDefaultCMacCVSThreadedTaskStackSize);																																	
											CMacCVSThreadedTask( 		CMacCVSDoc									*inOwnerDoc,
																							const UInt32 								inStackSize = kDefaultCMacCVSThreadedTaskStackSize);																										
			virtual 				~CMacCVSThreadedTask();
			
			
			virtual void		SetCompletionEvent(			AppleEvent 									&inCurEvent, 
																							AppleEvent 									&inReplyEvent);
																							
			virtual void		SendCompletionEvent();
			
			virtual void		AddToCompletionEvent(		const OSErr									inError);
			virtual void		AddToCompletionEvent(		const Str255								inErrorPStr);

			virtual void		PostFileError(					const FSSpec								*inTargetItem,
																							const char									*inPathStr,
																							const UInt32								inPathLen,
																							const SInt32								inError);

			virtual void		PostOverallError(				const SInt32								inError);
		
			virtual void		GetErrorString( 				const SInt32 								inError, 
																							Str255 											outErrorPStr);

			virtual void		GetTaskName							(Str255											outNamePStr);
																																																																														
		protected:
		
			AppleEvent			mCurrentEvent;
			AppleEvent			mReplyEvent;	
		
			CMacCVSDoc			*mOwnerDoc;
			
	};
	
