//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//################################################################################

/* -------------------------------------------------------------------------------

	File:				CMacCVSWatchTask.h
	
	Authors:		Ram Rajadhyaksha
	
	Description:
	
		This file contains code to run CVS Watch operations.
		 
	Modification History:

		12 May 	1999	Ram Rajadhyaksha
		
			First Created.
							
-------------------------------------------------------------------------------- */


#pragma once


#include <LListener.h>
#include "CMacCVSOperationTask.h"


class CMacCVSDoc;


class CMacCVSWatchTask:

	public CMacCVSOperationTask,
	public LListener

	{
		public:
		
			enum
				{				
					kWatchAdd				= 1,
					kWatchRemove 		= 2,
					kWatchNotify		= 3
				};
			
			class CMacCVSWatchTaskItem
				{
					public:
					
						UInt32 									mOperation;
						FSSpec									mFileSpec;
						CCVSEngineWatchOptions	mOptions;
						
						void Init( void )
							{
								mOperation 					= 0;
								mFileSpec.name[0] 	= 0;
								mFileSpec.parID 		= 0;
								mFileSpec.vRefNum 	= 0;
								mOptions.Init();
							}
				};	
				
											CMacCVSWatchTask( 		 	LArray													*inItems,
																							CMacCVSDoc											*inOwnerDoc);
			virtual 				~CMacCVSWatchTask();

			virtual void 		Run();	

			static pascal SInt32 Notifier(					const CCVSEngineRef							inEngineRef,
																							const FSSpec										*inTargetItem,
																							const SInt32 										inEvent, 
																							const SInt32 										inError, 
																							const UInt32 										inCookie, 
																							const void 											*inDataPtr, 
																							void 														*inContextPtr);

			virtual void		ListenToMessage(				MessageT												inMessage,
																							void														*ioParam);
			
			virtual void		GetTaskName( 						Str255 													outNamePStr);
																											
		protected:
		
			CCVSEngineRef							mEngineRef;			
			UInt32										mProgressID;
			UInt32										mOldMaxValue;
			UInt32										mIterations;
			Boolean										mReset;				
			
			LArray										mItemList;
																						
	};
	