// 
//	CPathPopup.cp
// 
//
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//	Description:
//
//		Provides the Finder like path popup for cmd-clicks in the title area
//		of a window.
//
//	Notes:
//
//		Users of this class will probably want to do so by overriding the
//		LWindow::ClickInDrag().  When a cmd-click is detected in the title
//		area of the window, do the following.
//		
//			CPathPopup thePathPop(this, theSpec);
//			thePathPop.Track();
//
//		This object relies on the following resources:
//
//			STR#	STRx_Popup	-	strings for menu building
// 

#pragma once

class CPathPopup
{
	public:
	
						enum {
								kFolderIconID		 = 257,
								kDiskIconID,
								kFileIconID
						};
	
	
						CPathPopup(
							const FSSpec&	inSpec,
							ResIDT 			inTextTraitsID = 0,
							Boolean			inAllowOpen = false,
							Boolean			inSwitchToFinder = false,
							Boolean			inShowIcons = false);
							
						~CPathPopup();
					
		void			Track(Point inGlobalPoint);
		
	protected:
		void			BuildPathMenu(void);
		void			DoAEOpenFolder(Int16 inMenuValue);
	
	private:
		void 			SetMenuItemIcon(Int16 inPathLength, const char *inPartialPath, Int16 inItemIndex);
	
	protected:
	
		MenuHandle		mMenu;
		FSSpec			mSpec;
		ResIDT			mTraitsID;
		Boolean			mAllowOpen;
		Boolean			mFinderSwitch;
		Boolean			mTargetIsDirectory;
		
		// icon stuff
		Boolean			mShowIcons;
		LArray			*mIconSuites;
};
