//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//
//		File: 	CProgressIndicator.h
//
//	  Author: Dan Clifford
//
//################################################################################


#pragma once

#include <LPane.h>


class CProgressIndicator: 	
	
	public LPane,
	public LPeriodical 
	
	{
	
		public:
		
			enum 
				{
					class_ID 					= 'PGin',
					kUpdateFrequency	= 20,
					kTypeTime					= 1,
					kTypeScalar				= 2,
					kTypeDontMarch		= 4
				};
		
			CProgressIndicator(LStream *inStream);
			~CProgressIndicator();
			
			static 	CProgressIndicator 	*CreateProgressIndicatorFromStream( LStream 	*inStream );

			virtual void 								DrawSelf();
			virtual UInt32							GetProgress() 
				{ return mCurrentBarFill; }
			
			virtual UInt32 							GetMaximumProgress() 
				{ return mMaximumBarFill; }
			
			virtual void 								SetMaximumProgress(									UInt32 		newMax );
			
			virtual void 								Progress(														UInt32		inDelta);
			virtual void 								Done();
			
			virtual void 								SetAbsoluteValue(										UInt32 		inNewVal); 
		
		virtual	void SpendTime(const EventRecord &inMacEvent);
		virtual void SetProgressType(UInt8	inProgressType);
	
	protected:
	
		virtual void	ActivateSelf();
		virtual void	DeactivateSelf();

	private:
		UInt32					mStartTicks;
		UInt8						mProgressType;
		UInt32					mMaximumBarFill;
		UInt32					mCurrentBarFill;
		Boolean					mDrawBusyBar;
		UInt32					mLastBusyUpdate;
		UInt32					mWhichPatternPosition;
		Boolean					mDone;
		UInt32					mLastProgress;
		
		ControlHandle		mProgressBarControl;		// for use with Appearance Manager
};