//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//
//		File: 		CProgressWindow.h
//
//	  Author: 	Dan Clifford
//
//################################################################################

#pragma once

#include <LWindow.h>
#include <QDOffscreen.h>
#include <LStdControl.h>
#include <LButton.h>

#include "CProgressIndicator.h"
#include "CMacCVSThreadedWindow.h"

typedef OSType ProgressID;


class CProgressWindow : 
	
	public CMacCVSWindow
	
	{
	
		private:
				
			typedef CMacCVSWindow		Inherited;
			
		public:
	
			enum 
				{
				
					class_ID 										= 'pgwn',
					kProgressIDFile 						= 'pfil',
					kProgressIDOverall 					= 'povr',
					kProgressOverallIndicatorID	= 'PGi1',
					kProgressFileIndicatorID		= 'PGi2',
					kProgressMessageCaptionID		= 'itmm',
					kProgressCountCaptionID			= 'itmc',
					kProgressItemCaptionID			= 'itmt'
				
				};
		
															CProgressWindow(									LStream 				*inStream);
															~CProgressWindow();
		
			static CProgressWindow 	*CreateProgressWindowFromStream(	LStream 				*inStream);
		
			void										SetProgressDeterminate( 					Boolean 				inIsDeterminate);

			void										SetProgressType( 									ProgressID			inID, 
																																UInt8						inProgressType);
																																																													
			void 										SetMaximumProgress(								ProgressID			inID, 
																																UInt32 					maxProgressAmount);
																																
			
			void										SetAbsoluteValue(									ProgressID 			inID, 
																																UInt32 					inVal);
			
																															
			void										MakeTimeBasedProgress(						ProgressID 			inID, 
																																UInt32 					inExpectedTime);
																																
			void										FinishCreateSelf();
				
			CProgressIndicator*			ProgressIDToIndicator(						ProgressID 			inID);

			void										SetProgressMessageText(						ConstStringPtr 	inNewText,
																																const	Boolean		inRefresh = true);

			void										SetProgressWindowTitle( 					ConstStringPtr 	inNewText );

			void										SetProgressCountText(							UInt32					inValue,
																																const	Boolean		inRefresh = true);
																																
			void										SetCurrentItemText(								ConstStringPtr	inNewText,
																																const	Boolean		inRefresh = true);
				
			void										DrawProgressCountText();
			void										DrawProgressMessageText();
			void										DrawCurrentItemText();
	
			void										DrawSelf();
		
		protected:
	
			CProgressIndicator		*mFileIndicator;
			
			Str255								mProgressCountText;
			Str255								mCurrentItemText;
			Str255								mProgressMessageText;
					
			UInt32								mProgressCount;
	
			Rect									mProgressCountTextRect,
														mCurrentItemTextRect,
														mProgressMessageTextRect;
			
			GWorldPtr							mProgressCountGWorld,
														mCurrentItemGWorld,
														mProgressMessageGWorld;
																																				
	};