//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//
//			File: 		CSpinIndicator.h
//
//	  	Author: 	Dan Clifford
//
//################################################################################


#pragma once


#include <LPane.h>
#include <LListener.h>

#include "CThreadedTask.h"


class CSpinIndicatorThread;


class CSpinIndicator: 

	public LPane, 
  public LListener 
  
  {

		friend class CSpinIndicatorThread;
		
		public:
		
			enum 
				{
				
					class_ID													= 'spin',
					
					kFirstNonZeroFrame  							= 1,
					kTotalSpinFrames									= 9,
					
					msg_SpinWaitBegin									= 'swbg',
					msg_SpinWaitEnd										= 'swen',
					msg_SpinNoMoreWaiters							= 'swnm',
					
					kSpinIndicatorStackSize						= 10 * 1024,
					kSleepTimeBetweenArrowAdvances		= 50

				
				};
			
															CSpinIndicator(									LStream 							*inStream);
			virtual									~CSpinIndicator();
			
			static CSpinIndicator 	*CreateCSpinIndicatorFromStream(LStream 							*inStream);

			virtual void						Advance();
			virtual void 						ResetIndicator();
			
			virtual void 						DrawSelf();
			
			virtual void						ListenToMessage(								MessageT							inMessage,
																															void									*ioParam);
																															
			static pascal void 			*Run(														void									*inContextPtr);
			
		protected:
			
			virtual void						FinishCreateSelf();
			virtual void						ThreadedTaskDied(								const CThreadedTask 	*inTask);
			
			UInt32									mSpinWaitFrame,
															mLatentSpinWaitFrame;
										
			SInt32									mSpinWaiters;
										
			CSpinIndicatorThread		*mSpinThread;

	};
	
	
class CSpinIndicatorThread:

	public CThreadedTask
	
	{
	
		friend class CSpinIndicator;

		public:
		
										CSpinIndicatorThread( CSpinIndicator &inOwnerView);
			virtual				~CSpinIndicatorThread();
			
			virtual	void	Run();
			
		protected:
		
			CSpinIndicator		*mOwnerView;
	
	};
	
