//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//################################################################################


/* -------------------------------------------------------------------------------

	File:				MacCVSPPConstants.h
	
	Authors:		Ram Rajadhyaksha
	
	Description:
	
		This file contains all the PowerPlant Constructor resource IDs and other
		random crap for MacCVS Pro.
		 
	Modification History:

		21 Apr	1999		Josef W. Wankerl
		
					Added Reveal In Finder menu item constant.
		
		11 Apr	1999		Josef W. Wankerl
		
					Add the CLocalTreeView class type (for drag and drop on the
					local tree view in the preferences dialog).
		
		17 March 1999
		
					File created.

-------------------------------------------------------------------------------- */


#pragma once


//  Window Types

//  We used the refcon field in the window record
//  to identify what type of window the thing is.

enum 
	{
		kProjectViewWindowKind									= 32069,
		kLurkersViewWindowKind									= 32070,
		kFileLogViewWindowKind									= 32071,
		kFileStatusViewWindowKind								= 32072,
		kCompareViewWindowKind									= 32073
	};
	

//  Constructor Constants

	
enum
	{	
		//  Project Window Cnst Values

		kMacCVSDocumentWindowID									= 128,
		kMacCVSLurkersWindowID									= 133,

		kProjectRootLabelID											= 'pjrt',
		kLocalRootLabelID												= 'lcrt',
		kCurrentProjectLabelID									= 'crpj',
		kSortByStatusButtonID										= 'stst',
		kSortByNameButtonID											= 'stnm',
		kSortByVersionButtonID 									= 'stvr',
		kSortByModDateButtonID									= 'stdt',
		kSortByTagButtonID											= 'sttg',
		
		//  Prefs Dialog Cnst Values

		kMacCVSPreferenceWindowID								= 131,
		kPrefsOKButtonID												= 'okok',
		kPrefsCancelButtonID										= 'cncl',
		kPrefsPanelPopupID											= 'PPOP',
		kPrefsPanelPopupValueMessage						= 'PPOP',

		//  Checkout Panel Values

		kCheckoutUpdatePanelViewID							= 'CHUP',
		kCVSLocalDirectoryButtonID							= 'lpst',
		kCVSLocalDirectoryButtonMessageValue		= 'lpst',
		kCVSLocalDirectoryLabelID								= 'lcpt',
		kAutoMergeTextBinaryID									= 'aamg',
		kAutoMergeTextOnlyID										= 'toam',
		kNeverAutoMergeID												= 'nvam',
		kOutputDirectoryUpdatesID								= 'OUTD',
		kOutputFileUpdatesID										= 'OUTF',
		kModuleNameItemID												= 'mdle',
		kDefaultTagPopupID											= 'TAGP',
		kDefaultTagItemID												= 'dtag',
		kUseCompressionCheckBoxID								= 'CMCK',
		kCompressionPopupID											= 'CMLV',

		//  Remote Host Panel

		kRemotePanelViewID											= 'RMTE',
		kLocalTreeViewID												= 'DrLT',	// JWW - Drop Local Tree
		kHostNamePreferenceItemID								= 'host',
		kUserNamePreferenceItemID								= 'user',
		kCVSUserNamePreferenceItemID						= 'cvsn',
		kCVSRemotePasswordItemID								= 'cvsp',
		kCVSCommandPreferenceItemID 						= 'CCMD',
		kCVSRootPreferenceItemID								= 'cvsr',
		kDefaultRepositoryItemID								= 'dfrp',
		kAuthenticationMethodPopupID						= 'auth',
		kNetworkTimeOutItemID										= 'TOEF',
		kSavePasswordCheckBoxID									= 'SPAS',
		
		// Authentication method popup menu items

		kAuthenticationPasswordItem							= 1,
		kAuthenticationRSHItem									= 2,
		kAuthenticationKClientItem							= 3,

		//  Mapping View Panel

		kFileMappingPanelViewID									= 'MAPP',
		kFileMappingAddButtonID									= 'BADD',
		kFileMappingAddButtonMessage						= 'BADD',
		kFileMappingRemoveButtonID							= 'BRMV',
		kFileMappingRemoveButtonMessage					= 'BRMV',
		kFileMappingEditButtonID								= 'BEDT',
		kFileMappingEditButtonMessage						= 'BEDT',
		
		//  Misc Panel View

		kMiscPanelViewID												= 'MISC',
		kZoomRectsCheckBoxID										= 'ZOOM',
		kClearMessageWindowCheckBoxID						= 'MESG',
		kScrollMessageWindowCheckBoxID					= 'MSRL',
		kFolderListViewCheckBoxID								= 'LIST',
		kPropagateFolderLabelsCheckBoxID				= 'LPRP',
		
		kCheckoutUpdatePanelMenuItemID					= 1,
		kRemotePanelMenuItemID									= 2,
		kFileMappingPanelMenuItemID							= 3,
		kMiscPanelMenuItemID										= 4,
				
		kRevisionMenuItemID											= 1,
		kDateMenuItemID													= 2,
		
		//  Progress Window Cnst Values

		kProgressWindowPPob											= 129,
		kProgressWindowStopButtonID							= 'cncl',

		//  Lurkers Dialog Cnst Values

		kLurkersDialogPPobID										= 138,
		kLurkersDialogOKButtonID								= 'okok',
		kLurkersDialogCancelButtonID						= 'cncl',
		
		kSearchInTreeRadioButtonID							= 'STRE',
		kSearchInSelectionRadioButtonID					= 'SSEL',
		kSearchRadioGroupID											= 'SRCH',
		
		kFindModifiedRadioButtonID							= 'FMOD',
		kFindUnmodifiedRadioButtonID						= 'FUMD',
		kFindNewCheckboxID											= 'FNEW',
		kFindRadioGroupID												= 'FIND',
		
		kUseTagGroupID													= 'UTAG',
		kUseTagCheckboxGroupMessageValue				= 'UTAG',
		kOnTagRadioButtonID											= 'ONTG',
		kOnTagRadioMessageValue									= 'ONTG',
		kOffTagRadioButtonID										= 'OFFT',
		kOffTagRadioMessageValue								= 'OFFT',
		kTagRadioGroupID												= 'OTAG',
		kTagPopupID															= 'TPOP',
		kTagPopupMessageValue										= 'TPOP',

		kLurkersDialogRemoveButtonID						= 'rmve',
		kLurkersDialogRemoveButtonMessageValue	= 'rmve',

		/*
		kSelectionPopupID												= 'SPOP',
		kSelectionPopupMessageValue							= 'SPOP',
		kTreeSelectionMenuItemID								= 1,
		kCurSelectionMenuItemID									= 2,
		kModifiedPopupID												= 'MPOP',
		kModifiedPopupMessageValue							= 'MPOP',
		kModifiedMenuItemID											= 1,
		kNotModifiedMenuItemID									= 2,
		kOnTagPopupID														= 'OPOP',
		kOnTagPopupMessageValue									= 'OPOP',
		kIgnoreTagMenuItemID										= 1,
		kOnTagMenuItemID												= 2,
		kNotOnTagMenuItemID											= 3,
		*/

//	Wipe Info dialog
		kOrphanFilesDialogPPobID								= 155,
		kOrphanFilesDialogOKButtonID						= 'okok',
		kOrphanFilesDialogCancelButtonID				= 'cncl',
		kOrphanSelectedFilesRadioID							= 'sfls',
		kOrphanEntireTreeRadioID								= 'etre',
		kRemoveCkidResourcesCheckboxID					= 'ckid',
		kRemoveMcvsResourcesCheckboxID					= 'mcvs',
		kRemoveCVSDirectoriesCheckboxID					= 'cdir',

		//	Save on close dialog

		kCloseDialogPPobID											= 132,
		kCloseDialogOKButtonID									= 'okok',
		kCloseDialogCancelButtonID							= 'cncl',
		kCloseDialogMessageCaptionID						= 'msg ',
	
		kSaveDialogPPobID												= 144,
		kSaveDialogCaptionID										= 'msg ',
		kSaveDialogSaveButtonID									= 'okok',
		kSaveDialogCancelButtonID								= 'cncl',
		kSaveDialogDontSaveButtonID							= 'dosv',
		kSaveDialogDontSaveButtonValueMessage		= 'dosv',

		//  CVS Add Window

		kMacCVSAddDialogPPobID									= 145,
		kMacCVSAddDialogOKButtonID							= 'okok',
		kMacCVSAddDialogCancelButtonID					= 'cncl',
		kMacCVSAddDialogCancelAllButtonID				= 'cnca',
		kMacCVSAddDialogFileCaptionID						= 'atxt',
		kMacCVSAddDialogEncodingCaptionID				= 'ECAP',
		kMacCVSAddDialogEncodingPopupID					= 'EPOP',
		kMacCVSAddDialogBinaryButtonID					= 'BINA',
		kMacCVSAddDialogAppleSingleButtonID			= 'APPS',
		kMacCVSAddDialogBinhexButtonID					= 'BNHX',
		kMacCVSAddDialogMacBinaryButtonID				= 'MBIN',
		kMacCVSAddDialogUseforAllCheckboxID			= 'UALL',
		kMacCVSAddDialogUseforAllCheckboxValueMessage = 'UALL',
		
		//  CVS Commit Window

		kMacCVSCommitWindowID										= 135,
		kMacCVSCommitCaptionPaneID							= 'atxt',
		kMacCVSCommitCommentTEPaneID						=	'cicm',
		kMacCVSCommitAskForEachRadioMessage			= 'aske',
		kMacCVSCommitAskForEachRadioPaneID			= 'aske',
		kMacCVSCommitAskOnlyRadioMessage				= 'asko',
		kMacCVSCommitAskOnlyRadioPaneID					= 'asko',
		kMacCVSCommitUseForAllRadioMessage 			= 'usec',
		kMacCVSCommitUseForAllRadioPaneID				= 'usec',
		kMacCVSCommitOkButtonPaneID							= 'ckin',
		kMacCVSCommitOkButtonValueMessage				= 'ckin',
		kMacCVSCommitCancelButtonPaneID					= 'cncl',
		kMacCVSCommitCancelButtonValueMessage		= 'cncl',

		//  Comment Dialog
	
		kMacCVSCommentDialogPPobID							= 130,
		kMacCVSCommentDialogTEID								= 'cmnt',
		kMacCVSCommentDialogOKButtonID					= 'okok',
		kMacCVSCommentDialogCancelButtonID			= 'cncl',

		//  Checkout Module To Dialog

		kCheckoutModuleToDialogPPobID						= 141,
		kCheckoutModuleToOKButtonID							= 'okok',
		kCheckoutModuleToCancelButtonID					= 'cncl',
		kCheckoutModuleToRemoveButtonID					= 'rmve',
		kCheckoutModuleToRemoveButtonValueMessage = 'rmve',
		kCheckoutModuleToTagPopupID							= 'TPOP',
		kCheckoutModuleToTagPopupValueMessage		= 'TPOP',
		kCheckoutModuleToModuleFieldID					= 'modl',
		
		//  Checkout To/Update To/Revert File To Dialog

		kUpdateToDialogPPobID										= 137,
		kCheckoutToDialogPPobID									= 140,
		kRevertFileToDialogPPobID								= 148,
		kUpdateToOKButtonID											= 'okok',
		kUpdateToCancelButtonID									= 'cncl',
		kUpdateToRemoveButtonID									= 'rmve',
		kUpdateToRemoveButtonValueMessage				= 'rmve',
		kUpdateToTagPopupID											= 'TPOP',
		kUpdateToTagPopupValueMessage						= 'TPOP',

		//  Import Dialog

		kImportDialogPPobID											= 147,
		kImportPathCaptionTextTraitsID					= 130,
		kImportOKButtonID												= 'okok',
		kImportCancelButtonID										= 'cncl',
		kImportPathCaptionID										= 'PATH',
		kImportRepositoryEditFieldID						= 'modl',
		kImportVendorTagEditFieldID							= 'vent',
		kImportReleaseTagEditFieldID						= 'relt',
		kImportBranchTagEditFieldID							= 'brat',

		//  Tag Dialog

		kTagDialogPPobID												= 139,
		kTagDialogOKButtonID										= 'okok',
		kTagDialogCancelButtonID								= 'cncl',
		kTagDialogTagEditFieldID								= 'tagf',
		kTagDialogStaticRadioButtonID						= 'stat',
		kTagDialogBranchRadioButtonID						= 'bran',
		kTagDialogRemoveCheckBoxID							= 'remv',
		kTagDialogRemoveCheckBoxValueMessage		= 'remv',
		
		//  Remove Tag Dialog

		kRemoveTagDialogPPobID									= 149,
		kRemoveTagDialogOKButtonID							= 'okok',
		kRemoveTagDialogCancelButtonID					= 'cncl',
		kRemoveTagDialogTagEditFieldID					= 'tagf',

		//  Password Dialog
		
		kPasswordDialogPPobID										= 153,
		kPasswordDialogOKButtonID								= 'okok',
		kPasswordDialogCancelButtonID						= 'cncl',
		kPasswordDialogFieldID									= 'pasf',
		
		//  Revert Dialog

		kRevertDialogPPobID											= 154,
		kRevertDialogOKButtonID									= 'okok',
		kRevertDialogCancelButtonID							= 'cncl',
		kRevertDialogMessageFieldID							= 'msg ',
	
		//  Standard dialog box

		kAskOKCancelDialogPPobID								= 143,
		kAskOKCancelDialogOKButtonID						= 'okok',
		kAskOKCancelDialogCancelButtonID				= 'cncl',
		kAskOKCancelDialogCaptionID							= 'msg '		
	};

	
//  Command Constants

//  Constants for PowerPlant menu items.


enum 
	{
		cmd_RevealInFinder						= 4000,		// JWW added 04/21/99

		cmd_CopyPath							= 5001,
		cmd_EditPreferences				= 5000,
		cmd_ShowAll								= 5002,

		cmd_Update								= 6000,
		cmd_UpdateTo							= 6001,
		cmd_Checkout							= 6003,
		cmd_CheckoutTo						= 6004,
		cmd_CheckoutDefaultModule	= 6005,
		cmd_CheckoutModuleTo			= 6006,

		cmd_AddFile								= 6007,
		cmd_Commit								= 6008,
	
		cmd_Editors								= 6018,
		cmd_Watchers							= 6019,
		
		cmd_Import								= 6017,
		cmd_RevertFile						= 6009,
		cmd_RemoveFiles						= 6015,
		cmd_Tag										= 6016,

		cmd_OrphanFiles						= 6014,

		cmd_ModifyReadOnly				= 6012,
		cmd_EditComment						= 6013,
		
		cmd_FindLurkers						= 7000,
		cmd_CompareWithOriginal		= 7001,
		cmd_Diff									= 7002,
		cmd_GetFileLog 						= 7003,
		cmd_GetFileStatus					= 7004,
		cmd_AdvancedDiff					= 7005,
			
		cmd_MessageWindow					= 8001,
	
		cmd_Edit									= 9000,
		cmd_UnEdit								= 9001,
		cmd_ShowEditors						= 9002,
		
		cmd_WatchOn								= 10000,
		cmd_WatchOff							= 10001,
		cmd_WatchAdd							= 10002,
		cmd_WatchRemove						= 10003,
		cmd_ShowWatchers					= 10004		
	};


//  Error codes
					

enum
	{
		kUnknownErr											= 300,
		kInvalidParamErr								= 301,
		kOutdatedPrefsErr								= 302,
		kUnknownPrefsVersionErr					= 303,
		kUnknownFileFormatErr						= 304,
		kNoRootSpecifiedErr							= 305,
		kNoZeroLengthModuleNameErr			= 306,
		kCantImportCVSDirectoryErr			= 307,
		kCantImportRootDirErr						= 308,
		kCantHaveZeroLengthFieldErr			= 309,
		kMappingAlreadyExistsErr				= 310,
		kImportFieldsRequiredErr				= 311,
		kNeedServerSettingsErr					= 402,
		kAuthenticationMethodUnknownErr	= 403,
		kWillUpdatePrefsStr							= 1,
		kMustSetRootStr									= 1
	};