//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//
//		File: 		UKeyScrollAttachments.h
//	
//	  Authors: 	Simon Fraser & Patrick Beard
//
//################################################################################

#pragma once

#include <LString.h>
#include <UAttachments.h>
#include <LArray.h>

class UTableKeyScrollAttachment:
	
	public LKeyScrollAttachment
	{
		public:
			enum { class_ID = 'tksa' };
		
					UTableKeyScrollAttachment(LView		*inViewToScroll);
					UTableKeyScrollAttachment(LStream	*inStream);
	
		protected:

			virtual void	ExecuteSelf(MessageT inMessage, void *ioParam);
			virtual Boolean	SelectPrefixedItem(const LString& prefix, TableIndexT& ioStartIndex) = 0;
			virtual void OpenItem(const STableCell& inCell) = 0;
		
			LTableView		*mTableView;
			
			// PCB:  type-ahead support.
			TString<Str63>	mKeyBuffer;
			UInt32					mLastKeyTime;
			TableIndexT			mCurrentRow;
	};

class USimpleKeyScrollAttachment:
	
	public UTableKeyScrollAttachment
	{
		public:
			enum { class_ID = 'cksa' };
		
					USimpleKeyScrollAttachment(LView		*inViewToScroll);
					USimpleKeyScrollAttachment(LStream	*inStream);
	
		protected:
	
	
		virtual void	ExecuteSelf(MessageT inMessage, void *ioParam);
		virtual void 	OpenItem(const STableCell& inCell) {};
		virtual Boolean	SelectPrefixedItem(const LString& prefix, TableIndexT& ioStartIndex) { return false; };
	};
	
class ULurkersKeyScrollAttachment:
	
	public UTableKeyScrollAttachment
	{
		public:
			enum { class_ID = 'lksa' };
		
					ULurkersKeyScrollAttachment(LView		*inViewToScroll);
					ULurkersKeyScrollAttachment(LStream	*inStream);
	
		protected:
	
	
		virtual void	ExecuteSelf(MessageT inMessage, void *ioParam);
		virtual Boolean	SelectPrefixedItem(const LString& prefix, TableIndexT& ioStartIndex);
		virtual void OpenItem(const STableCell& inCell);
	};
	
	
class UProjectKeyScrollAttachment:
	
	public UTableKeyScrollAttachment
	{
		public:
			enum { class_ID = 'pksa' };
		
					UProjectKeyScrollAttachment(LView		*inViewToScroll);
					UProjectKeyScrollAttachment(LStream	*inStream);
					
		virtual		~UProjectKeyScrollAttachment();
	
		protected:
	
	
		virtual void	ExecuteSelf(MessageT inMessage, void *ioParam);
		virtual Boolean	SelectPrefixedItem(const LString& prefix, TableIndexT& ioStartIndex);
		virtual void	OpenItem(const STableCell& inCell);
		
		void			SortVisibleItems();
		
		LArray*			mSortedItems;
	};
	