
#include <Files.h>

#include "ThrowOSErr.h"
#include "StringUtils.h"
#include "CVSEngine.h"
#include "CVSEngineUtils.h"
#include "CCVSEntries.h"
#include "IDEMacCVSUtils.h"



OSErr 
FSpGetRevisionInfo( const FSSpec *fsInTarget, Str255 pstrOutRevision, Str255 pstrOutTimeStamp,
								    Str255 pstrOutOptions, Str255 pstrOutTag)
	{
	
		OSErr 	result 		= noErr;
		FSSpec	fsTarget	= { 0, 0, "\p" };
		FSSpec	fsParent 	= { 0, 0, "\p" };
			
		Str255	pstrRevision = "\p";
		Str255	pstrTimeStamp = "\p";
		Str255	pstrOptions	= "\p";
		Str255	pstrTag	= "\p";
		
		try
			{	
				if ( fsInTarget == NULL )
					{
						ThrowOSErr( kCVSEngineBadParamErr );
					}
	
				fsTarget = *fsInTarget;
				
				result = FSpGetParentFSSpec( &fsTarget, &fsParent );
				ThrowOSErr( result );
				
				CCVSEntries theEntries;
				
				result = theEntries.LoadWorkingDirectory( &fsParent, fsRdPerm );
				ThrowOSErr( result );
				
				result = theEntries.GetEntry( fsTarget.name, pstrRevision, pstrTimeStamp, pstrOptions, pstrTag );
				ThrowOSErr( result );
				
				//  sizeof(pstrOutRevision) will probably return
				//  4 bytes, so use sizeof(Str255)
				
				if ( pstrOutRevision != NULL )
					{
						PStrCopy( pstrRevision, pstrOutRevision, sizeof(Str255) );
					}

				if ( pstrOutTimeStamp != NULL )
					{
						PStrCopy( pstrTimeStamp, pstrOutTimeStamp, sizeof(Str255) );
					}

				if ( pstrOutOptions != NULL )
					{
						PStrCopy( pstrOptions, pstrOutOptions, sizeof(Str255) );
					}

				if ( pstrOutTag != NULL )
					{
						PStrCopy( pstrTag, pstrOutTag, sizeof(Str255) );
					}					
			}
		catch ( OSErr intException )
			{
				result = intException;
			}
		catch ( ... )
			{
				result = kCVSEngineUnknownExceptionErr;
			}
			
		return result;

	}
