//	NewWithFree.cp		1994-1997 Metrowerks Corporation. All rights reserved

//	A way to clean up the "new" memory pools to prevent these as memory leaks
//	in a code resource.

//	Taken (verbatium) from the "Code Resource Examples:-CW Code Resource Info:
//	Memory Problems in CRs:FreeAllC++Memory:1 Build code resource:" example,
//	written by Mark Anderson

#include "NewWithFree.h"

#include <New.cp>


#if NEWMODE==NEWMODE_NORMAL
/************************************************************************/
/*	void FreeAllCplusMemory(void)										*/
/*	Purpose..: 	Dispose all memory										*/
/*	Input....:	---				*/
/*	Return...:	---														*/
/************************************************************************/
void FreeAllCplusMemory(void)
{
	FreeMemList	*temp;

	while (memlist.next)
	{
		temp = (memlist.next)->next;
		if (GetPtrSize((Ptr)(memlist.next)))  // it's a "real" Ptr
			DisposePtr((Ptr)(memlist.next));
		memlist.next = temp;
	}
	memlist.size = 0; 		// reinitialize memlist
}
#elif NEWMODE==NEWMODE_FAST
/************************************************************************/
/*	void FreeAllCplusMemory(void)										*/
/*	Purpose..: 	Dispose all memory										*/
/*	Input....:	---				*/
/*	Return...:	---														*/
/************************************************************************/
void FreeAllCplusMemory(void)
{
	MemPool	*temp;

	while (mempools)
	{
		temp = mempools->next;
		DisposePtr((Ptr)mempools);
		mempools = temp;
	}
	lastfree = NULL;		//	pointer to last free block
	lastend = NULL;			//	pointer to last end
	
}
#endif

