//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//
//		File: 		CMacCVSPreferencesFile.cp
//	
//	  Authors: 	Dan Clifford
//
//################################################################################


#include "CMacCVSPreferenceFile.h"
#include "LHandleStream.h"

unsigned char CMacCVSPreferenceFile::sFileName[] = "\pMacCVS Preferences";
static CMacCVSPreferenceFile *sPreferencesFile = NULL;

CMacCVSPreferenceFile::
CMacCVSPreferenceFile(): LPreferencesFile(sFileName, true)
{
	mProjectRootLocation[0] = 0;
	mLocalRootLocation[0] = 0;
}

void CMacCVSPreferenceFile::StreamIn(LStream *stream)
{
	stream->ReadPString(mProjectRootLocation);
	stream->ReadPString(mLocalRootLocation);
}

void CMacCVSPreferenceFile::StreamOut(LStream *stream)
{
	stream->WritePString(mProjectRootLocation);
	stream->WritePString(mLocalRootLocation);
}

void CMacCVSPreferenceFile::SetProjectRoot(ConstStr255Param newPath)
{
	BlockMove(newPath, mProjectRootLocation, newPath[0] + 1);
}

void CMacCVSPreferenceFile::SetLocalRoot(ConstStr255Param newPath)
{
	BlockMove(newPath, mLocalRootLocation, newPath[0] + 1);
}

void 
CMacCVSPreferenceFile::GetProjectRoot(StringPtr newPath)
{
	BlockMove(mProjectRootLocation, newPath, mProjectRootLocation[0] + 1);
}

void 
CMacCVSPreferenceFile::GetLocalRoot(StringPtr newPath)
{
	BlockMove(mLocalRootLocation, newPath, mLocalRootLocation[0] + 1);
}

CMacCVSPreferenceFile *
CMacCVSPreferenceFile::GetPreferenceFile()
{
	Handle	preferenceFileData;

	if (sPreferencesFile == NULL) {
		sPreferencesFile = new CMacCVSPreferenceFile();
		sPreferencesFile->OpenOrCreateResourceFork(fsRdWrPerm, 'mCVS', 'pref', smSystemScript);
		sPreferencesFile->OpenDataFork(fsRdWrPerm);
	
		preferenceFileData = sPreferencesFile->ReadDataFork();
		
		if (GetHandleSize(preferenceFileData) != NULL) {
			
			LHandleStream newStream(preferenceFileData);
			sPreferencesFile->StreamIn(&newStream);
	
		}
	}
	
	return sPreferencesFile;

}

void
CMacCVSPreferenceFile::ClosePreferencesFile()
{
	LHandleStream newStream;
	sPreferencesFile->StreamOut(&newStream);
	Handle dataHandle = newStream.GetDataHandle();
	sPreferencesFile->WriteDataFork(*dataHandle, GetHandleSize(dataHandle));
	delete sPreferencesFile;
}
