//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//
//		File: 	CMacCVSProjectItemDragTask.cp
//
//	  Author: Scott M. Silver
//
//################################################################################


#include <Events.h>
#include "CMacCVSProjectItemDragTask.h"

CMacCVSProjectItemDragTask::CMacCVSProjectItemDragTask(	const EventRecord	&inEventRecord, LArray &inSelectedItems, RgnHandle inSelectionRgn ) :
	
	LDragTask(inEventRecord),
	mSelectedItems( sizeof(FSSpec) )

	{
	
		Rect theRect = { 0, 0, 16, 16 };
		
		::UnionRgn( mDragRegion, inSelectionRgn, mDragRegion );
		//::RectRgn(mDragRegion, &theRect);
			
		if ( inSelectedItems.GetCount() > 0 )
			mSelectedItems = inSelectedItems;
			
	}

				
void 
CMacCVSProjectItemDragTask::AddFlavors( DragReference inDragRef )
	{

		OSErr				result				= noErr;
		FSSpec			theCurItem		= { 0, 0, "\p" };
		UInt32			maxIndex			= 0;
		HFSFlavor		theCurFlavor;
		FInfo				finderInfo;
		CInfoPBRec	pb;
		
		pb.hFileInfo.ioCompletion = NULL;
		pb.hFileInfo.ioFDirIndex = 0;
		pb.hFileInfo.ioNamePtr = NULL;
		pb.hFileInfo.ioVRefNum = 0;
		pb.hFileInfo.ioDirID = 0;
		
		maxIndex = mSelectedItems.GetCount();
		
		for ( UInt32 index = 1; index <= maxIndex; index++ )
			{	
				
				if ( mSelectedItems.FetchItemAt(index, &theCurItem) )
					{

//  Hack- Make sure the item still exists before adding
//  it to the drag reference.
				
						pb.hFileInfo.ioNamePtr = theCurItem.name;
						pb.hFileInfo.ioVRefNum = theCurItem.vRefNum;
						pb.hFileInfo.ioDirID = theCurItem.parID;
						
						result = ::PBGetCatInfoSync( &pb );
						
						if ( result == noErr )
							{
							
								theCurFlavor.fileSpec = theCurItem;
								::FSpGetFInfo(&theCurFlavor.fileSpec, &finderInfo);

								theCurFlavor.fileType = finderInfo.fdType;
								theCurFlavor.fileCreator = finderInfo.fdCreator;
								theCurFlavor.fdFlags = finderInfo.fdFlags;

//  We pass the index as a unique item reference.
				
								::AddDragItemFlavor( inDragRef, (ItemReference)index, flavorTypeHFS, &theCurFlavor, sizeof(theCurFlavor), 0 );
				
							}
							
					}
					
			}
			
	}


void 
CMacCVSProjectItemDragTask::MakeDragRegion( DragReference inDragRef, RgnHandle inDragRegion )
	{
	
		// we don't have to do anything interesting here (it was done in CMacCVSProjectItemDragTask)
	
	}		
	
				