//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//
//		File: 		CMacCVSProjectViewHeader.cp
//
//	  	Author: 	Dan Clifford
//
//################################################################################


#include <UDrawingUtils.h>
#include "CMacCVSProjectViewHeader.h"


CMacCVSProjectViewHeader::
CMacCVSProjectViewHeader(LStream *inStream):LView(inStream)
{

}


CMacCVSProjectViewHeader::
~CMacCVSProjectViewHeader()
{

}


CMacCVSProjectViewHeader *
CMacCVSProjectViewHeader::CreateCMacCVSProjectViewHeaderStream(LStream *inStream)
{

	return new CMacCVSProjectViewHeader(inStream);

}


void
CMacCVSProjectViewHeader::DrawSelf()
{
	
	Rect			frameRect;
	RGBColor		lightGrey 	= { 0xFFFF, 0xFFFF, 0xFFFF };
	RGBColor		mediumGrey 	= { 0xEEEE, 0xEEEE, 0xEEEE };
	RGBColor		darkGrey 	= { 0xBBBB, 0xBBBB, 0xBBBB };
	StColorPenState	savedState;
	
	savedState.Normalize();
	
	BackColor(whiteColor);
	ForeColor(blackColor);
	
	CalcLocalFrameRect(frameRect);

	::RGBForeColor(&lightGrey);

	MoveTo(frameRect.left, frameRect.bottom - 2);
	LineTo(frameRect.left, frameRect.top);
	LineTo(frameRect.right - 2, frameRect.top);
	
	::RGBForeColor(&darkGrey);
	
	MoveTo(frameRect.right - 1, frameRect.top + 1);
	LineTo(frameRect.right - 1, frameRect.bottom - 1);
	LineTo(frameRect.left + 1, frameRect.bottom - 1);
	
	::RGBForeColor(&mediumGrey);
	
	MoveTo(frameRect.left, frameRect.bottom - 1);
	Line(0, 0);

	MoveTo(frameRect.right - 1, frameRect.top);
	Line(0, 0);

	::InsetRect(&frameRect, 1, 1);
	::PaintRect(&frameRect);
	
}
