//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//
//			File: 		CMacCVSShowEditorsTask.cp
//	
//	  	Authors: 	Ram Rajadhyaksha
//
//################################################################################


#include "UErrorDialog.h"

#include "CMacCVSMessageView.h"
#include "CMacCVSMessageWindow.h"

#include "CSpinIndicator.h"
#include "CMacCVSDoc.h"
#include "CVSEngine.h"
#include "CMacCVSStatusWindow.h"
#include "CMacCVSShowEditorsTask.h"


CMacCVSShowEditorsTask::CMacCVSShowEditorsTask( const CMacCVSStatusWindow *inOwnerWindow, CMacCVSDoc *inOwnerDoc,
			const FSSpec *inTargetItem ):

	CMacCVSWindowTask( inOwnerWindow, inOwnerDoc )
		
	{
		mTargetItem.name[0] = 0;
		mTargetItem.parID		= 0;
		mTargetItem.vRefNum = 0;

		if ( inTargetItem != NULL )
			{
				mTargetItem = *inTargetItem;
			}

		SetEventNotifier( Notifier );
	}
	

CMacCVSShowEditorsTask::~CMacCVSShowEditorsTask()
	{
	}

	
OSErr
CMacCVSShowEditorsTask::DoEngineCommand()
	{	
		return CVSEngineEditors( mEngineRef, &mTargetItem, CMacCVSStatusWindow::StatusNotifier, mOwnerWindow );
	}
	
	
pascal SInt32		
CMacCVSShowEditorsTask::Notifier(
														const CCVSEngineRef					inEngineRef,
														const FSSpec								*inTargetItem,
														const SInt32 								inEvent, 
														const SInt32 								inError, 
														const UInt32 								inCookie, 
														const void 									*inDataPtr, 
														void 												*inContextPtr)
	{
	
		OSErr								error				= noErr;
		Boolean							bResult			= true;
		CMacCVSStatusTask		*theTask		= (CMacCVSStatusTask *)inContextPtr;
		
		if ( theTask != NULL )
			{			
				try
					{
						if ( inError != noErr )
							{
								if ( (inError != kCVSEngineSkippedFile) && (inError != kCVSEngineOperationAbortedErr) )
									{
										theTask->PostFileError( inTargetItem, NULL, 0, inError );
									}
							}
							
						switch ( inEvent )
							{
								case kCVSEngineYieldActionEvent:
									CThreadedTask::Yield();
								break;
							}	
					}					
				catch ( ... )
					{					
						bResult = false;						
					}					
			}
			
		return bResult;
		
	}
	

void
CMacCVSShowEditorsTask::GetTaskName( Str255 outNamePStr )
	{
		LStr255		theNameStr;
		
		theNameStr = "\pshow editors task";
			
		if ( theNameStr[0] > 0 )
			::BlockMoveData( theNameStr, outNamePStr, theNameStr[0] + 1 );
	}


