//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//
//			File: 		MacCVSRandomFrontEndCrap.cp
//	
//	  	Authors: 	Ram Rajadhyaksha
//
//################################################################################


#include "MacCVSRandomFrontEndCrap.h"


void 			AlertUser( const short inErrorCode, const Boolean inFatalFlag )
/* 
**  AlertUser() pops up a dialog box with a string of text that we pass to it. 
**  This is used to alert the user if something is gone wrong- like the fact that 
**  their computer's microprocessor is melting down and is dying a slow, painful death. 
**  The second parameter is a passed boolean that shuts down the program is the error 
**  is serious enough to warrent. 
*/
{

	OSErr		theErrorCode 	= inErrorCode;

	DialogPtr	theDialog		= NULL;
	GrafPtr		oldPort			= NULL;

	SInt16		theItemHit 		= 0x0000;
	SInt16		theItemType		= 0x0000;

	Str255		theMessage		= "\pError du-ude! Pass the bowl!";
	Str255		quitStr 		= "\pQuit";

	Rect		theItemRect		= { 0, 0 };
	Handle		theItemHndl		= NULL;
		
	GetPort(&oldPort);
	theDialog = GetNewDialog(rErrorAlert, NULL, (WindowPtr)-1);
	
	if (theDialog != NULL) {
	
		SetPort(theDialog);
		
/* 
**  Get error string from resource, don't bother checking for error... 
*/

		if ((theErrorCode < eUnknownError) || (theErrorCode > eLastErrCode))
			theErrorCode = eUnknownError;
			
		GetIndString(theMessage, rErrorStrings, theErrorCode);	
		ParamText(theMessage, NULL, NULL, NULL);	
		
		if (inFatalFlag) {
		
			GetDialogItem(theDialog, 1, &theItemType, &theItemHndl, &theItemRect);
			
			if (theItemHndl != NULL)
				SetControlTitle((ControlHandle)theItemHndl, quitStr);
				
		}
		
		SysBeep(30);
		SetCursor(&qd.arrow);		

		CenterWindowOnMainScreen(theDialog);
		ShowWindow(theDialog);
		
		OutlineButton(theDialog, 1);
		
		while (theItemHit != 1)
		
			ModalDialog(NULL, &theItemHit);
			
		CloseDialog(theDialog);
		SetPort(oldPort);
		
	}

	if (inFatalFlag == true)	
			
		ExitToShell();
		
} 


void CenterWindowOnMainScreen( WindowPtr inTheWindow )
/*
**  This is a lame function to center a window on the screen.
**  It will only work on the main screen.
*/
{
	
	Rect	windowRect		= { 0, 0 };
	short	menuBarHeight	= 0x0000;
	short	h				= 0x0000, 
			v				= 0x0000;
		
	menuBarHeight = GetMBarHeight();
	windowRect = inTheWindow->portRect;
	
	h = ((qd.screenBits.bounds.right - qd.screenBits.bounds.left) / 2) - ((windowRect.right - windowRect.left) / 2);
	v = ((qd.screenBits.bounds.bottom - qd.screenBits.bounds.top - menuBarHeight) / 2) - ((windowRect.bottom - windowRect.top) / 2);
	
	MoveWindow(inTheWindow, h, v, true);
			
}


void OutlineButton( DialogPtr inDialogPtr, const short inDialogItem )
/* 
**  Outline_Button() puts that silly outline around the default button 
**  in a dialog box. Keep in mind that the function only draws it once so 
**  if the dialog box is covered by another window, the outline will have 
**  to be redrawn. 
*/
{

	GrafPtr		oldPort		= NULL;
	Handle		theItemHndl	= NULL;
	
	PenState	oldPenState;
	
	short		theItemType	= 0x0000;
	Rect		theItemRect = { 0, 0 };
	
	if (inDialogPtr != NULL) {
	
		GetPort(&oldPort);
		SetPort(inDialogPtr);
		GetPenState(&oldPenState);
		
		GetDialogItem(inDialogPtr, inDialogItem, &theItemType, &theItemHndl, &theItemRect);
		
		PenSize(3,3);
		InsetRect(&theItemRect, -4, -4);
		FrameRoundRect(&theItemRect, 16, 16);
		
		SetPenState(&oldPenState);
		SetPort(oldPort);
		
	}
	
}

