//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//
//		File: 		UFileUtilities.cp
//
//	  Authors: 	Simon Fraser
//
//################################################################################


#include <LString.h>


#include "UFileUtilities.h"


Boolean UFileUtils::IsFolder(const FSSpec& spec)
	{
		TString<Str63> 		name(spec.name);
		CInfoPBRec 				pb = {0};
		
		pb.hFileInfo.ioNamePtr = name;
		pb.hFileInfo.ioVRefNum = spec.vRefNum;
		pb.hFileInfo.ioDirID = spec.parID;
		pb.hFileInfo.ioFDirIndex = 0;
		
		OSErr err = PBGetCatInfoSync(&pb);
		
		if (err != noErr) return false;
		return (pb.dirInfo.ioFlAttrib & ioDirMask) != 0;
	}
