//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//
//		File: 		UMacCVSUtils.cp
//
//	  Authors: 	Scott M. Silver and Ram Rajadhyaksha
//
//################################################################################


#include <string.h>
#include <ctype.h>

#include "UMacCVSUtils.h"


Boolean
UMacCVSUtils::ExtractPhrase( char *inSrcData, UInt32 inSrcLen, char inSeperator, UInt32 inWhichPhrase, char *outPhrase, UInt32 *outPhraseLen )
	{
		
		char			currentCharacter	= 0x00;
		UInt32		maxOutputSize 		= *outPhraseLen,
							actualOutputSize 	= 0;
		
		*outPhrase = 0;
		*outPhraseLen = 0;

//	Position the cursor at the beginning of the 
//	phrase that we actually want.

		while ( inWhichPhrase > 1 ) 
			{
					
				while (1) 
					{
					
						if (inSrcLen == 0)
							return false;
							
						currentCharacter = *inSrcData;
							
						inSrcData++;
						inSrcLen--;
				
						if (currentCharacter == inSeperator)
							break;
					
					}
					
				inWhichPhrase--;
				
			}

//	Copy the desired phrase into the output buffer

		while (1) 
			{
			
				if ( inSrcLen == 0 )
					break;
					
				if ( maxOutputSize == 0 )
					break;
					
				currentCharacter = *inSrcData;

				if ( currentCharacter == inSeperator )
					break;
					
				*outPhrase++ = currentCharacter;
			
				inSrcData++;
				actualOutputSize++;
				maxOutputSize--;
				inSrcLen--;
				
			}
		
		if ( maxOutputSize > 0 )
			*outPhrase++ = '\0';
		
		*outPhraseLen = actualOutputSize;

		return true;	
		
	}


void
UMacCVSUtils::RelativeDateString(	UInt32 inDateSeconds, Str255 outDateString )
	{

	 	DateTimeRec	now, printDate;
		UInt32 nowSeconds;

	 	::GetTime(&now);
		::DateToSeconds(&now, &nowSeconds);
		::SecondsToDate(inDateSeconds, &printDate);

		TString<Str255> theDateString;
	 
	 	//	If the the date is within the last seven days, print it specially.
	 	Int32 dayDifference = (nowSeconds / kSecondsInDay) - (inDateSeconds / kSecondsInDay);
	 	
	 	if (dayDifference <= 7)
	 		{
	 		
		 		if (dayDifference == 0)
				
					theDateString = "\pToday, ";
				
				else if (dayDifference == 1)
				
					theDateString = "\pYesterday, ";
				
				else if (dayDifference == -1)
				
					theDateString = "\pTomorrow, ";
					
				else
					{
					
						switch (printDate.dayOfWeek)
							{
						
								case 2:
									theDateString = "\pLast Monday, ";
									break;

								case 3:
									theDateString = "\pLast Tuesday, ";
									break;

								case 4:
									theDateString = "\pLast Wednesday, ";
									break;

								case 5:
									theDateString = "\pLast Thursday, ";
									break;

								case 6:
									theDateString = "\pLast Friday, ";
									break;

								case 7:
									theDateString = "\pLast Saturday, ";
									break;

								case 1:
									theDateString = "\pLast Sunday, ";
									break;
									
							}
				
					}
				
		 	}
	 	else
	 		{
	 		
		 		::DateString(inDateSeconds, abbrevDate, theDateString, NULL);
		 		theDateString += "\p, ";
		 	
		 	}

		TString<Str255> theTimeString;
		
		::TimeString(inDateSeconds, false, theTimeString, NULL);
		theDateString += theTimeString;

		LString::CopyPStr(theDateString, outDateString);
		
	}


SInt32 UMacCVSUtils::sSecondsFromGMT = -1;

/*
	UnixTimeToMacSeconds
	
	Takes a unix string from the date output of the log view
	and converts into seconds on this Macintosh.  We take into
	account GMT conversion.
*/

UInt32
UMacCVSUtils::UnixTimeToMacSeconds( char *timeString )
{
	UInt32		result 		= 0;
	SInt32		tempNum;
	Str255		tempString;
	DateTimeRec	theDate;

	// get our difference from GMT
	if (sSecondsFromGMT == -1)
	{
		MachineLocation location;
		
		::ReadLocation(&location);
		
		// so it turns out this value they give is a 3 byte SIGNED value..this is to get the
		// right sign extension
		sSecondsFromGMT = ((SInt32) ((location.u.gmtDelta & 0x00FFFFFF) << 8)) >> 8; // only top 3 work
	}	
	
	
	if (timeString != NULL)
	{
		if (strlen(timeString) == 19) 
		{
			BlockMove(timeString, tempString + 1, 4);
			tempString[0] = 4;
			/*
			**  With six calls to StringToNum(), you might as will
			**  write a quickie CharToNum() function and do the
			**  addition of powers.
			*/		
			StringToNum(tempString, &tempNum);
			theDate.year = tempNum;
			
			tempString[0] = 2;
			tempString[1] = timeString[5];
			tempString[2] = timeString[6];
			
			StringToNum(tempString, &tempNum);
			theDate.month = tempNum;
			
			tempString[1] = timeString[8];
			tempString[2] = timeString[9];

			StringToNum(tempString, &tempNum);
			theDate.day = tempNum;
			
			tempString[1] = timeString[11];
			tempString[2] = timeString[12];
			
			StringToNum(tempString, &tempNum);
			theDate.hour = tempNum;
			
			tempString[1] = timeString[14];
			tempString[2] = timeString[15];
			
			StringToNum(tempString, &tempNum);
			theDate.minute = tempNum;
			
			tempString[1] = timeString[17];
			tempString[2] = timeString[18];
			
			StringToNum(tempString, &tempNum);
			theDate.second = tempNum;
			
			DateToSeconds(&theDate, &result);
			result += sSecondsFromGMT;
		}
	}
		
	return (result);
}


pascal void
UMacCVSUtils::Rot15PStr( Str255 inOutCryptStr )
	{

		UInt32	len = 0x00;
		
		if ( inOutCryptStr != NULL ) 
			{
			
				len = inOutCryptStr[0];
				
				for ( UInt32 index = 1; index <= len; index++ )
					{
					
						inOutCryptStr[index] += 15;
						
					}
					
			}
		
	}
	
	
pascal void
UMacCVSUtils::ReverseRot15PStr( Str255 inOutCryptStr )
	{

		UInt32	len = 0x00;
		
		if ( inOutCryptStr != NULL ) 
			{
			
				len = inOutCryptStr[0];
				
				for ( UInt32 index = 1; index <= len; index++ )
					{
					
						inOutCryptStr[index] -= 15;
						
					}
					
			}
		
	}
	
	

char 
UMacCVSUtils::ReadWord( const char *inBuf, const UInt32 inBufLen, UInt32 *inOutIndex, char *outWordStr, UInt32 *inOutWordLen, const char *inTerm )
	{
	
		Boolean		done						= false;
		
		char			*curTerminator	= NULL,
							result					= 0x00;
		
		UInt32		len							= 0x00000000;
		
		if ( 	(inBuf != NULL) && 
					(inBufLen > 0) && 
					(inOutIndex != NULL) && 
					(outWordStr != NULL) && 
					(inOutWordLen != NULL) && 
					(inTerm != NULL) && 
					(strlen(inTerm) > 0) ) 
			{
		
				while ( !done ) 
					{
						
						if ( ((*inOutIndex) < inBufLen) && (len < (*inOutWordLen)) ) 
							{
								
								for ( curTerminator = (char *)inTerm; *curTerminator != '\0'; curTerminator++ ) 
									{
									
										if ( inBuf[(*inOutIndex)] == *curTerminator)
											{

												result = *curTerminator;

												done = true;
												
											} 
										
									}
											
								if ( !done ) 
								
									outWordStr[len++] = inBuf[(*inOutIndex)];
						
								(*inOutIndex)++;
																					
							} 
							
						else done = true;
						
					}
				
				*inOutWordLen = len;
			
			} 
		else inOutWordLen = 0;
		
		return result;

	}
	
	
