//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//
//		File: 		UMenuUtilities.cp
//
//	  Authors: 	Simon Fraser
//
//################################################################################

#include <UTextTraits.h>
#include <LString.h>

#include "UMenuUtilities.h"


//---------------------RemoveMenuItems-------------------------------

void UMenuUtils::RemoveMenuItems(MenuHandle inMenu, Int16 inLastKeep)
	{
		Int16 numItems = ::CountMItems(inMenu) - inLastKeep;
		
		while (numItems > 0)
			{
				::DeleteMenuItem(inMenu, inLastKeep + 1);
				numItems--;
			}
	}

//---------------------InsertMenuItem-------------------------------

Int16 UMenuUtils::InsertMenuItem(
					MenuHandle 			inMenu,
					ConstStringPtr	inText,
					Int16 					inAfter,
					Boolean					inEnabled)
	{
		Int16 itemIndex;
		Int16 numItems;
		
		if (inAfter == 0)
			itemIndex = 1;
		else
			{
			numItems = ::CountMItems(inMenu);
			if (inAfter >= numItems)
				itemIndex = numItems + 1;
			else
				itemIndex = inAfter + 1;
			}

		if (inEnabled)
			::InsertMenuItem(inMenu, "\pn", inAfter);
		else
			::InsertMenuItem(inMenu, "\p(n", inAfter);
		
		::SetMenuItemText(inMenu, itemIndex, inText);
		
		return itemIndex;
	}


//---------------------InsertMenuItem-------------------------------

Int16 UMenuUtils::AppendMenuItem(
						MenuHandle				inMenu,
						ConstStringPtr		inString,
						Boolean						inEnabled)
	{
		Int16 itemIndex = ::CountMItems(inMenu) + 1;
		
		if (inEnabled)
			::AppendMenu(inMenu, "\pn");
		else
			::AppendMenu(inMenu, "\p(n");			//here's a closing brace ) so that the IDE does not get confused
			
		::SetMenuItemText(inMenu, itemIndex, inString);
		
		return itemIndex;
	}



//---------------------SetItemIconFromResID-------------------------------

void
UMenuUtils::SetItemIconFromResID(
					MenuHandle				inMenu,
					Int16							inItemIndex,
					ResIDT						inIconID)
	{
	
		//::SetItemCmd(inMenu, inItemIndex, 0x1D);						//use reduced icon
		::SetItemIcon(inMenu, inItemIndex, inIconID - 256);
		
	}
	
	
//---------------------AppendSeparator-------------------------------

void UMenuUtils::AppendSeparator(MenuHandle inMenu)
{
	::AppendMenu(inMenu, "\p(-");				//here's a closing brace ) so that the IDE does not get confused
}


//---------------------PopupWithTraits-------------------------------

Int32 UMenuUtils::PopupWithTraits(
											MenuHandle 		inMenu,
											Point					inGlobalWhere,
											Int16 				inTopItem,
											ResIDT				inTraitsID)
	{
		TextTraitsH theTraits = UTextTraits::LoadTextTraits(inTraitsID);
		
		CGrafPtr theWindowMgrPort;
		::GetCWMgrPort(&theWindowMgrPort);
		
		Int16 saveFontFam = LMGetSysFontFam();
		Int16 saveFont = theWindowMgrPort->txFont;
		Int16 saveSize = theWindowMgrPort->txSize;
		Int16 saveFace = theWindowMgrPort->txFace;
		
		theWindowMgrPort->txFont = (*theTraits)->fontNumber;
		theWindowMgrPort->txSize = (*theTraits)->size;
		theWindowMgrPort->txFace = (*theTraits)->style;
		LMSetSysFontFam((*theTraits)->fontNumber);

		Int32 theResult = ::PopUpMenuSelect(inMenu, inGlobalWhere.v, inGlobalWhere.h, inTopItem);
		
		theWindowMgrPort->txFont = saveFont;
		theWindowMgrPort->txSize = saveSize;
		theWindowMgrPort->txFace = saveFace;
		LMSetSysFontFam(saveFontFam);

		return theResult;
	}

