//################################################################################
//
//  Copyright (C) 1997-1998 Netscape Communications Corporation.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//
//		File: 		URegionUtilities.cp
//
//	  Authors: 	Simon Fraser
//
//################################################################################


#include "URegionUtilities.h"


void	URegionUtils::Hilite(RgnHandle inRegion)
{
	StColorPenState	savePen;

	PenPat(&UQDGlobals::GetQDGlobals()->black);
	PenMode(srcXor);
	UDrawingUtils::SetHiliteModeOn();
	InvertRgn(inRegion);
}


void	URegionUtils::MakeRegionOutline(RgnHandle inRegion, RgnHandle *ioRgn)
{
	OSErr		err = noErr;
	Boolean		createdRgn = false;
	
	ThrowIfNULL_(ioRgn);
	ThrowIfNULL_(inRegion);

	if (inRegion == *ioRgn) {
		StRegion	tempRgn(inRegion);
		
		InsetRgn(tempRgn, 1, 1);
								ThrowIfOSErr_(QDError());
		DiffRgn(inRegion, tempRgn, *ioRgn);	//	of course, inRegion & *ioRgn are the same!
								ThrowIfOSErr_(QDError());
	} else {
		if (*ioRgn == NULL) {
			*ioRgn = NewRgn();
			createdRgn = true;
		}
		ThrowIfNULL_(*ioRgn);

		Try_ {
			//	Get outline
			CopyRgn(inRegion, *ioRgn);
									ThrowIfOSErr_(QDError());
			InsetRgn(*ioRgn, 1, 1);
									ThrowIfOSErr_(QDError());
			DiffRgn(inRegion, *ioRgn, *ioRgn);
									ThrowIfOSErr_(QDError());
			
		} Catch_(inErr) {
		
			if (createdRgn && *ioRgn) {
				DisposeRgn(*ioRgn);
				*ioRgn = NULL;
			}
	
			Throw_(inErr);
		} EndCatch_;
	}	
}
